require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_ARM_CPUTYPES_H_)) {
    eval 'sub _ARM_CPUTYPES_H_ () {1;}' unless defined(&_ARM_CPUTYPES_H_);
    eval 'sub CPU_ID_IMPLEMENTOR_MASK () {0xff000000;}' unless defined(&CPU_ID_IMPLEMENTOR_MASK);
    eval 'sub CPU_ID_ARM_LTD () {0x41000000;}' unless defined(&CPU_ID_ARM_LTD);
    eval 'sub CPU_ID_BROADCOM () {0x42000000;}' unless defined(&CPU_ID_BROADCOM);
    eval 'sub CPU_ID_CAVIUM () {0x43000000;}' unless defined(&CPU_ID_CAVIUM);
    eval 'sub CPU_ID_DEC () {0x44000000;}' unless defined(&CPU_ID_DEC);
    eval 'sub CPU_ID_INFINEON () {0x49000000;}' unless defined(&CPU_ID_INFINEON);
    eval 'sub CPU_ID_MOTOROLA () {0x4d000000;}' unless defined(&CPU_ID_MOTOROLA);
    eval 'sub CPU_ID_NVIDIA () {0x4e000000;}' unless defined(&CPU_ID_NVIDIA);
    eval 'sub CPU_ID_APM () {0x50000000;}' unless defined(&CPU_ID_APM);
    eval 'sub CPU_ID_QUALCOMM () {0x51000000;}' unless defined(&CPU_ID_QUALCOMM);
    eval 'sub CPU_ID_SAMSUNG () {0x53000000;}' unless defined(&CPU_ID_SAMSUNG);
    eval 'sub CPU_ID_TI () {0x54000000;}' unless defined(&CPU_ID_TI);
    eval 'sub CPU_ID_MARVELL () {0x56000000;}' unless defined(&CPU_ID_MARVELL);
    eval 'sub CPU_ID_APPLE () {0x61000000;}' unless defined(&CPU_ID_APPLE);
    eval 'sub CPU_ID_FARADAY () {0x66000000;}' unless defined(&CPU_ID_FARADAY);
    eval 'sub CPU_ID_INTEL () {0x69000000;}' unless defined(&CPU_ID_INTEL);
    eval 'sub CPU_ID_ISOLD {
        my($x) = @_;
	    eval q(((($x) & 0xf000) == 0x));
    }' unless defined(&CPU_ID_ISOLD);
    eval 'sub CPU_ID_IS7 {
        my($x) = @_;
	    eval q(((($x) & 0xf000) == 0x7000));
    }' unless defined(&CPU_ID_IS7);
    eval 'sub CPU_ID_ISNEW {
        my($x) = @_;
	    eval q((! &CPU_ID_ISOLD($x)  && ! &CPU_ID_IS7($x)));
    }' unless defined(&CPU_ID_ISNEW);
    eval 'sub CPU_ID_FOUNDRY_MASK () {0xff0000;}' unless defined(&CPU_ID_FOUNDRY_MASK);
    eval 'sub CPU_ID_FOUNDRY_VLSI () {0x560000;}' unless defined(&CPU_ID_FOUNDRY_VLSI);
    eval 'sub CPU_ID_7ARCH_MASK () {0x800000;}' unless defined(&CPU_ID_7ARCH_MASK);
    eval 'sub CPU_ID_7ARCH_V3 () {0x;}' unless defined(&CPU_ID_7ARCH_V3);
    eval 'sub CPU_ID_7ARCH_V4T () {0x800000;}' unless defined(&CPU_ID_7ARCH_V4T);
    eval 'sub CPU_ID_7VARIANT_MASK () {0x7f0000;}' unless defined(&CPU_ID_7VARIANT_MASK);
    eval 'sub CPU_ID_ARCH_MASK () {0xf0000;}' unless defined(&CPU_ID_ARCH_MASK);
    eval 'sub CPU_ID_ARCH_V3 () {0x;}' unless defined(&CPU_ID_ARCH_V3);
    eval 'sub CPU_ID_ARCH_V4 () {0x10000;}' unless defined(&CPU_ID_ARCH_V4);
    eval 'sub CPU_ID_ARCH_V4T () {0x20000;}' unless defined(&CPU_ID_ARCH_V4T);
    eval 'sub CPU_ID_ARCH_V5 () {0x30000;}' unless defined(&CPU_ID_ARCH_V5);
    eval 'sub CPU_ID_ARCH_V5T () {0x40000;}' unless defined(&CPU_ID_ARCH_V5T);
    eval 'sub CPU_ID_ARCH_V5TE () {0x50000;}' unless defined(&CPU_ID_ARCH_V5TE);
    eval 'sub CPU_ID_ARCH_V5TEJ () {0x60000;}' unless defined(&CPU_ID_ARCH_V5TEJ);
    eval 'sub CPU_ID_ARCH_V6 () {0x70000;}' unless defined(&CPU_ID_ARCH_V6);
    eval 'sub CPU_ID_VARIANT_MASK () {0xf00000;}' unless defined(&CPU_ID_VARIANT_MASK);
    eval 'sub CPU_ID_PARTNO_MASK () {0xfff0;}' unless defined(&CPU_ID_PARTNO_MASK);
    eval 'sub CPU_ID_XSCALE_COREGEN_MASK () {0xe000;}' unless defined(&CPU_ID_XSCALE_COREGEN_MASK);
    eval 'sub CPU_ID_XSCALE_COREREV_MASK () {0x1c00;}' unless defined(&CPU_ID_XSCALE_COREREV_MASK);
    eval 'sub CPU_ID_XSCALE_PRODUCT_MASK () {0x3f0;}' unless defined(&CPU_ID_XSCALE_PRODUCT_MASK);
    eval 'sub CPU_ID_REVISION_MASK () {0xf;}' unless defined(&CPU_ID_REVISION_MASK);
    eval 'sub CPU_ID_CPU_MASK () {0xfffffff0;}' unless defined(&CPU_ID_CPU_MASK);
    eval 'sub CPU_ID_ARM2 () {0x41560200;}' unless defined(&CPU_ID_ARM2);
    eval 'sub CPU_ID_ARM250 () {0x41560250;}' unless defined(&CPU_ID_ARM250);
    eval 'sub CPU_ID_ARM3 () {0x41560300;}' unless defined(&CPU_ID_ARM3);
    eval 'sub CPU_ID_ARM600 () {0x41560600;}' unless defined(&CPU_ID_ARM600);
    eval 'sub CPU_ID_ARM610 () {0x41560610;}' unless defined(&CPU_ID_ARM610);
    eval 'sub CPU_ID_ARM620 () {0x41560620;}' unless defined(&CPU_ID_ARM620);
    eval 'sub CPU_ID_ARM700 () {0x41007000;}' unless defined(&CPU_ID_ARM700);
    eval 'sub CPU_ID_ARM710 () {0x41007100;}' unless defined(&CPU_ID_ARM710);
    eval 'sub CPU_ID_ARM7500 () {0x41027100;}' unless defined(&CPU_ID_ARM7500);
    eval 'sub CPU_ID_ARM710A () {0x41067100;}' unless defined(&CPU_ID_ARM710A);
    eval 'sub CPU_ID_ARM7500FE () {0x41077100;}' unless defined(&CPU_ID_ARM7500FE);
    eval 'sub CPU_ID_ARM710T () {0x41807100;}' unless defined(&CPU_ID_ARM710T);
    eval 'sub CPU_ID_ARM720T () {0x41807200;}' unless defined(&CPU_ID_ARM720T);
    eval 'sub CPU_ID_ARM740T8K () {0x41807400;}' unless defined(&CPU_ID_ARM740T8K);
    eval 'sub CPU_ID_ARM740T4K () {0x41817400;}' unless defined(&CPU_ID_ARM740T4K);
    eval 'sub CPU_ID_ARM810 () {0x41018100;}' unless defined(&CPU_ID_ARM810);
    eval 'sub CPU_ID_ARM920T () {0x41129200;}' unless defined(&CPU_ID_ARM920T);
    eval 'sub CPU_ID_ARM922T () {0x41029220;}' unless defined(&CPU_ID_ARM922T);
    eval 'sub CPU_ID_ARM926EJS () {0x41069260;}' unless defined(&CPU_ID_ARM926EJS);
    eval 'sub CPU_ID_ARM940T () {0x41029400;}' unless defined(&CPU_ID_ARM940T);
    eval 'sub CPU_ID_ARM946ES () {0x41049460;}' unless defined(&CPU_ID_ARM946ES);
    eval 'sub CPU_ID_ARM966ES () {0x41049660;}' unless defined(&CPU_ID_ARM966ES);
    eval 'sub CPU_ID_ARM966ESR1 () {0x41059660;}' unless defined(&CPU_ID_ARM966ESR1);
    eval 'sub CPU_ID_ARM1020E () {0x4115a200;}' unless defined(&CPU_ID_ARM1020E);
    eval 'sub CPU_ID_ARM1022ES () {0x4105a220;}' unless defined(&CPU_ID_ARM1022ES);
    eval 'sub CPU_ID_ARM1026EJS () {0x4106a260;}' unless defined(&CPU_ID_ARM1026EJS);
    eval 'sub CPU_ID_ARM11MPCORE () {0x410fb020;}' unless defined(&CPU_ID_ARM11MPCORE);
    eval 'sub CPU_ID_ARM1136JS () {0x4107b360;}' unless defined(&CPU_ID_ARM1136JS);
    eval 'sub CPU_ID_ARM1136JSR1 () {0x4117b360;}' unless defined(&CPU_ID_ARM1136JSR1);
    eval 'sub CPU_ID_ARM1156T2S () {0x4107b560;}' unless defined(&CPU_ID_ARM1156T2S);
    eval 'sub CPU_ID_ARM1176JZS () {0x410fb760;}' unless defined(&CPU_ID_ARM1176JZS);
    eval 'sub CPU_ID_ARM11_P {
        my($n) = @_;
	    eval q((($n & 0xff07f000) == 0x4107b000));
    }' unless defined(&CPU_ID_ARM11_P);
    eval 'sub CPU_ID_CORTEXA5R0 () {0x410fc050;}' unless defined(&CPU_ID_CORTEXA5R0);
    eval 'sub CPU_ID_CORTEXA7R0 () {0x410fc070;}' unless defined(&CPU_ID_CORTEXA7R0);
    eval 'sub CPU_ID_CORTEXA8R1 () {0x411fc080;}' unless defined(&CPU_ID_CORTEXA8R1);
    eval 'sub CPU_ID_CORTEXA8R2 () {0x412fc080;}' unless defined(&CPU_ID_CORTEXA8R2);
    eval 'sub CPU_ID_CORTEXA8R3 () {0x413fc080;}' unless defined(&CPU_ID_CORTEXA8R3);
    eval 'sub CPU_ID_CORTEXA9R1 () {0x411fc090;}' unless defined(&CPU_ID_CORTEXA9R1);
    eval 'sub CPU_ID_CORTEXA9R2 () {0x412fc090;}' unless defined(&CPU_ID_CORTEXA9R2);
    eval 'sub CPU_ID_CORTEXA9R3 () {0x413fc090;}' unless defined(&CPU_ID_CORTEXA9R3);
    eval 'sub CPU_ID_CORTEXA9R4 () {0x414fc090;}' unless defined(&CPU_ID_CORTEXA9R4);
    eval 'sub CPU_ID_CORTEXA15R2 () {0x412fc0f0;}' unless defined(&CPU_ID_CORTEXA15R2);
    eval 'sub CPU_ID_CORTEXA15R3 () {0x413fc0f0;}' unless defined(&CPU_ID_CORTEXA15R3);
    eval 'sub CPU_ID_CORTEXA15R4 () {0x414fc0f0;}' unless defined(&CPU_ID_CORTEXA15R4);
    eval 'sub CPU_ID_CORTEXA17R1 () {0x411fc0e0;}' unless defined(&CPU_ID_CORTEXA17R1);
    eval 'sub CPU_ID_CORTEXA32R1 () {0x411fd010;}' unless defined(&CPU_ID_CORTEXA32R1);
    eval 'sub CPU_ID_CORTEXA35R0 () {0x410fd040;}' unless defined(&CPU_ID_CORTEXA35R0);
    eval 'sub CPU_ID_CORTEXA35R1 () {0x411fd040;}' unless defined(&CPU_ID_CORTEXA35R1);
    eval 'sub CPU_ID_CORTEXA53R0 () {0x410fd030;}' unless defined(&CPU_ID_CORTEXA53R0);
    eval 'sub CPU_ID_CORTEXA55R1 () {0x411fd050;}' unless defined(&CPU_ID_CORTEXA55R1);
    eval 'sub CPU_ID_CORTEXA57R0 () {0x410fd070;}' unless defined(&CPU_ID_CORTEXA57R0);
    eval 'sub CPU_ID_CORTEXA57R1 () {0x411fd070;}' unless defined(&CPU_ID_CORTEXA57R1);
    eval 'sub CPU_ID_CORTEXA65R0 () {0x410fd060;}' unless defined(&CPU_ID_CORTEXA65R0);
    eval 'sub CPU_ID_CORTEXA72R0 () {0x410fd080;}' unless defined(&CPU_ID_CORTEXA72R0);
    eval 'sub CPU_ID_CORTEXA73R0 () {0x410fd090;}' unless defined(&CPU_ID_CORTEXA73R0);
    eval 'sub CPU_ID_CORTEXA75R2 () {0x412fd0a0;}' unless defined(&CPU_ID_CORTEXA75R2);
    eval 'sub CPU_ID_CORTEXA76AER1 () {0x411fd0e0;}' unless defined(&CPU_ID_CORTEXA76AER1);
    eval 'sub CPU_ID_CORTEXA76R3 () {0x413fd0b0;}' unless defined(&CPU_ID_CORTEXA76R3);
    eval 'sub CPU_ID_NEOVERSEN1R3 () {0x413fd0c0;}' unless defined(&CPU_ID_NEOVERSEN1R3);
    eval 'sub CPU_ID_NEOVERSEE1R1 () {0x411fd4a0;}' unless defined(&CPU_ID_NEOVERSEE1R1);
    eval 'sub CPU_ID_CORTEXA77R0 () {0x410fd0d0;}' unless defined(&CPU_ID_CORTEXA77R0);
    eval 'sub CPU_ID_CORTEX_P {
        my($n) = @_;
	    eval q((($n & 0xff0fe000) == 0x410fc000));
    }' unless defined(&CPU_ID_CORTEX_P);
    eval 'sub CPU_ID_CORTEX_A5_P {
        my($n) = @_;
	    eval q((($n & 0xff0ff0f0) == 0x410fc050));
    }' unless defined(&CPU_ID_CORTEX_A5_P);
    eval 'sub CPU_ID_CORTEX_A7_P {
        my($n) = @_;
	    eval q((($n & 0xff0ff0f0) == 0x410fc070));
    }' unless defined(&CPU_ID_CORTEX_A7_P);
    eval 'sub CPU_ID_CORTEX_A8_P {
        my($n) = @_;
	    eval q((($n & 0xff0ff0f0) == 0x410fc080));
    }' unless defined(&CPU_ID_CORTEX_A8_P);
    eval 'sub CPU_ID_CORTEX_A9_P {
        my($n) = @_;
	    eval q((($n & 0xff0ff0f0) == 0x410fc090));
    }' unless defined(&CPU_ID_CORTEX_A9_P);
    eval 'sub CPU_ID_CORTEX_A15_P {
        my($n) = @_;
	    eval q((($n & 0xff0ff0f0) == 0x410fc0f0));
    }' unless defined(&CPU_ID_CORTEX_A15_P);
    eval 'sub CPU_ID_CORTEX_A32_P {
        my($n) = @_;
	    eval q((($n & 0xff0ff0f0) == 0x410fd010));
    }' unless defined(&CPU_ID_CORTEX_A32_P);
    eval 'sub CPU_ID_CORTEX_A35_P {
        my($n) = @_;
	    eval q((($n & 0xff0ff0f0) == 0x410fd040));
    }' unless defined(&CPU_ID_CORTEX_A35_P);
    eval 'sub CPU_ID_CORTEX_A53_P {
        my($n) = @_;
	    eval q((($n & 0xff0ff0f0) == 0x410fd030));
    }' unless defined(&CPU_ID_CORTEX_A53_P);
    eval 'sub CPU_ID_CORTEX_A55_P {
        my($n) = @_;
	    eval q((($n & 0xff0ff0f0) == 0x410fd050));
    }' unless defined(&CPU_ID_CORTEX_A55_P);
    eval 'sub CPU_ID_CORTEX_A57_P {
        my($n) = @_;
	    eval q((($n & 0xff0ff0f0) == 0x410fd070));
    }' unless defined(&CPU_ID_CORTEX_A57_P);
    eval 'sub CPU_ID_CORTEX_A65_P {
        my($n) = @_;
	    eval q((($n & 0xff0ff0f0) == 0x410fd060));
    }' unless defined(&CPU_ID_CORTEX_A65_P);
    eval 'sub CPU_ID_CORTEX_A72_P {
        my($n) = @_;
	    eval q((($n & 0xff0ff0f0) == 0x410fd080));
    }' unless defined(&CPU_ID_CORTEX_A72_P);
    eval 'sub CPU_ID_CORTEX_A73_P {
        my($n) = @_;
	    eval q((($n & 0xff0ff0f0) == 0x410fd090));
    }' unless defined(&CPU_ID_CORTEX_A73_P);
    eval 'sub CPU_ID_CORTEX_A75_P {
        my($n) = @_;
	    eval q((($n & 0xff0ff0f0) == 0x410fd0a0));
    }' unless defined(&CPU_ID_CORTEX_A75_P);
    eval 'sub CPU_ID_CORTEX_A76_P {
        my($n) = @_;
	    eval q((($n & 0xff0ff0f0) == 0x410fd0b0));
    }' unless defined(&CPU_ID_CORTEX_A76_P);
    eval 'sub CPU_ID_CORTEX_A76AE_P {
        my($n) = @_;
	    eval q((($n & 0xff0ff0f0) == 0x410fd0e0));
    }' unless defined(&CPU_ID_CORTEX_A76AE_P);
    eval 'sub CPU_ID_CORTEX_A77_P {
        my($n) = @_;
	    eval q((($n & 0xff0ff0f0) == 0x410fd0f0));
    }' unless defined(&CPU_ID_CORTEX_A77_P);
    eval 'sub CPU_ID_THUNDERXRX () {0x43000a10;}' unless defined(&CPU_ID_THUNDERXRX);
    eval 'sub CPU_ID_THUNDERXP1d0 () {0x43000a10;}' unless defined(&CPU_ID_THUNDERXP1d0);
    eval 'sub CPU_ID_THUNDERXP1d1 () {0x43000a11;}' unless defined(&CPU_ID_THUNDERXP1d1);
    eval 'sub CPU_ID_THUNDERXP2d1 () {0x431f0a11;}' unless defined(&CPU_ID_THUNDERXP2d1);
    eval 'sub CPU_ID_THUNDERX81XXRX () {0x43000a20;}' unless defined(&CPU_ID_THUNDERX81XXRX);
    eval 'sub CPU_ID_THUNDERX83XXRX () {0x43000a30;}' unless defined(&CPU_ID_THUNDERX83XXRX);
    eval 'sub CPU_ID_THUNDERX2RX () {0x43000af0;}' unless defined(&CPU_ID_THUNDERX2RX);
    eval 'sub CPU_ID_SA110 () {0x4401a100;}' unless defined(&CPU_ID_SA110);
    eval 'sub CPU_ID_SA1100 () {0x4401a110;}' unless defined(&CPU_ID_SA1100);
    eval 'sub CPU_ID_EMAG8180 () {0x503f0002;}' unless defined(&CPU_ID_EMAG8180);
    eval 'sub CPU_ID_TI925T () {0x54029250;}' unless defined(&CPU_ID_TI925T);
    eval 'sub CPU_ID_MV88FR571_VD () {0x56155710;}' unless defined(&CPU_ID_MV88FR571_VD);
    eval 'sub CPU_ID_MV88SV131 () {0x56251310;}' unless defined(&CPU_ID_MV88SV131);
    eval 'sub CPU_ID_FA526 () {0x66015260;}' unless defined(&CPU_ID_FA526);
    eval 'sub CPU_ID_SA1110 () {0x6901b110;}' unless defined(&CPU_ID_SA1110);
    eval 'sub CPU_ID_IXP1200 () {0x6901c120;}' unless defined(&CPU_ID_IXP1200);
    eval 'sub CPU_ID_80200 () {0x69052000;}' unless defined(&CPU_ID_80200);
    eval 'sub CPU_ID_PXA250 () {0x69052100;}' unless defined(&CPU_ID_PXA250);
    eval 'sub CPU_ID_PXA210 () {0x69052120;}' unless defined(&CPU_ID_PXA210);
    eval 'sub CPU_ID_PXA250A () {0x69052100;}' unless defined(&CPU_ID_PXA250A);
    eval 'sub CPU_ID_PXA210A () {0x69052120;}' unless defined(&CPU_ID_PXA210A);
    eval 'sub CPU_ID_PXA250B () {0x69052900;}' unless defined(&CPU_ID_PXA250B);
    eval 'sub CPU_ID_PXA210B () {0x69052920;}' unless defined(&CPU_ID_PXA210B);
    eval 'sub CPU_ID_PXA250C () {0x69052d00;}' unless defined(&CPU_ID_PXA250C);
    eval 'sub CPU_ID_PXA210C () {0x69052d20;}' unless defined(&CPU_ID_PXA210C);
    eval 'sub CPU_ID_PXA27X () {0x69054110;}' unless defined(&CPU_ID_PXA27X);
    eval 'sub CPU_ID_80321_400 () {0x69052420;}' unless defined(&CPU_ID_80321_400);
    eval 'sub CPU_ID_80321_600 () {0x69052430;}' unless defined(&CPU_ID_80321_600);
    eval 'sub CPU_ID_80321_400_B0 () {0x69052c20;}' unless defined(&CPU_ID_80321_400_B0);
    eval 'sub CPU_ID_80321_600_B0 () {0x69052c30;}' unless defined(&CPU_ID_80321_600_B0);
    eval 'sub CPU_ID_80219_400 () {0x69052e20;}' unless defined(&CPU_ID_80219_400);
    eval 'sub CPU_ID_80219_600 () {0x69052e30;}' unless defined(&CPU_ID_80219_600);
    eval 'sub CPU_ID_IXP425_533 () {0x690541c0;}' unless defined(&CPU_ID_IXP425_533);
    eval 'sub CPU_ID_IXP425_400 () {0x690541d0;}' unless defined(&CPU_ID_IXP425_400);
    eval 'sub CPU_ID_IXP425_266 () {0x690541f0;}' unless defined(&CPU_ID_IXP425_266);
    eval 'sub CPU_ID_MV88SV58XX_P {
        my($n) = @_;
	    eval q((($n & 0xff0fff00) == 0x560f5800));
    }' unless defined(&CPU_ID_MV88SV58XX_P);
    eval 'sub CPU_ID_MV88SV581X_V6 () {0x560f5810;}' unless defined(&CPU_ID_MV88SV581X_V6);
    eval 'sub CPU_ID_MV88SV581X_V7 () {0x561f5810;}' unless defined(&CPU_ID_MV88SV581X_V7);
    eval 'sub CPU_ID_MV88SV584X_V6 () {0x561f5840;}' unless defined(&CPU_ID_MV88SV584X_V6);
    eval 'sub CPU_ID_MV88SV584X_V7 () {0x562f5840;}' unless defined(&CPU_ID_MV88SV584X_V7);
    eval 'sub CPU_ID_ARM_88SV581X_V6 () {0x410fb760;}' unless defined(&CPU_ID_ARM_88SV581X_V6);
    eval 'sub CPU_ID_ARM_88SV581X_V7 () {0x413fc080;}' unless defined(&CPU_ID_ARM_88SV581X_V7);
    eval 'sub CPU_ID_ARM_88SV584X_V6 () {0x410fb020;}' unless defined(&CPU_ID_ARM_88SV584X_V6);
}
1;
