require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_ARM_MUTEX_H_)) {
    eval 'sub _ARM_MUTEX_H_ () {1;}' unless defined(&_ARM_MUTEX_H_);
    if(defined(&_KERNEL)) {
    }
    if(defined(&__MUTEX_PRIVATE)) {
	eval 'sub mtx_owner () { ($u->{mtxa_owner});}' unless defined(&mtx_owner);
	eval 'sub mtx_ipl () { ($u->{s}->{mtxs_ipl});}' unless defined(&mtx_ipl);
	eval 'sub mtx_lock () { ($u->{s}->{mtxs_lock});}' unless defined(&mtx_lock);
	if(0) {
	    eval 'sub __HAVE_MUTEX_STUBS () {1;}' unless defined(&__HAVE_MUTEX_STUBS);
	    eval 'sub __HAVE_SPIN_MUTEX_STUBS () {1;}' unless defined(&__HAVE_SPIN_MUTEX_STUBS);
	}
	eval 'sub __HAVE_SIMPLE_MUTEXES () {1;}' unless defined(&__HAVE_SIMPLE_MUTEXES);
	if(defined(&MULTIPROCESSOR)) {
	    if(defined(&_ARM_ARCH_7)) {
		eval 'sub MUTEX_RECEIVE {
		    my($mtx) = @_;
    		    eval q( &__asm  &__volatile(\\"dmb\\" ::: \\"memory\\"));
		}' unless defined(&MUTEX_RECEIVE);
	    } else {
		eval 'sub MUTEX_RECEIVE {
		    my($mtx) = @_;
    		    eval q( &membar_consumer());
		}' unless defined(&MUTEX_RECEIVE);
	    }
	} else {
	    eval 'sub MUTEX_RECEIVE {
	        my($mtx) = @_;
    		eval q();
	    }' unless defined(&MUTEX_RECEIVE);
	}
	if(defined(&MULTIPROCESSOR)) {
	    if(defined(&_ARM_ARCH_7)) {
		eval 'sub MUTEX_GIVE {
		    my($mtx) = @_;
    		    eval q( &__asm  &__volatile(\\"dsb\\" ::: \\"memory\\"));
		}' unless defined(&MUTEX_GIVE);
	    } else {
		eval 'sub MUTEX_GIVE {
		    my($mtx) = @_;
    		    eval q( &membar_producer());
		}' unless defined(&MUTEX_GIVE);
	    }
	} else {
	    eval 'sub MUTEX_GIVE {
	        my($mtx) = @_;
    		eval q();
	    }' unless defined(&MUTEX_GIVE);
	}
	eval 'sub MUTEX_CAS {
	    my($p, $o, $n) = @_;
    	    eval q(( &atomic_cas_ulong(( &volatile \'unsigned long\' *)($p), ($o), ($n)) == ($o)));
	}' unless defined(&MUTEX_CAS);
	if(defined(&MULTIPROCESSOR)) {
	    eval 'sub MUTEX_SMT_PAUSE () {
	        eval q( &__asm  &__volatile(\\"wfe\\"));
	    }' unless defined(&MUTEX_SMT_PAUSE);
	    eval 'sub MUTEX_SMT_WAKE () {
	        eval q( &__asm  &__volatile(\\"sev\\"));
	    }' unless defined(&MUTEX_SMT_WAKE);
	}
    }
}
1;
