require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&GSSAPI_GSSAPI_H_)) {
    eval 'sub GSSAPI_GSSAPI_H_ () {1;}' unless defined(&GSSAPI_GSSAPI_H_);
    require 'stddef.ph';
    require 'krb5/krb5-types.ph';
    unless(defined(&BUILD_GSSAPI_LIB)) {
	if(defined(&_WIN32)) {
	    eval 'sub GSSAPI_LIB_FUNCTION () { &__declspec( &dllimport);}' unless defined(&GSSAPI_LIB_FUNCTION);
	    eval 'sub GSSAPI_LIB_CALL () { &__stdcall;}' unless defined(&GSSAPI_LIB_CALL);
	    eval 'sub GSSAPI_LIB_VARIABLE () { &__declspec( &dllimport);}' unless defined(&GSSAPI_LIB_VARIABLE);
	} else {
	    eval 'sub GSSAPI_LIB_FUNCTION () {1;}' unless defined(&GSSAPI_LIB_FUNCTION);
	    eval 'sub GSSAPI_LIB_CALL () {1;}' unless defined(&GSSAPI_LIB_CALL);
	    eval 'sub GSSAPI_LIB_VARIABLE () {1;}' unless defined(&GSSAPI_LIB_VARIABLE);
	}
    }
    unless(defined(&GSSAPI_DEPRECATED_FUNCTION)) {
	if(defined(&__GNUC__)  && (((defined(&__GNUC__) ? &__GNUC__ : undef) > 3) || (((defined(&__GNUC__) ? &__GNUC__ : undef) == 3)  && ((defined(&__GNUC_MINOR__) ? &__GNUC_MINOR__ : undef) >= 1)))) {
	    eval 'sub GSSAPI_DEPRECATED_FUNCTION {
	        my($X) = @_;
    		eval q( &__attribute__(( &deprecated)));
	    }' unless defined(&GSSAPI_DEPRECATED_FUNCTION);
	} else {
	    eval 'sub GSSAPI_DEPRECATED_FUNCTION {
	        my($X) = @_;
    		eval q();
	    }' unless defined(&GSSAPI_DEPRECATED_FUNCTION);
	}
    }
    if(defined(&__APPLE__)  && (defined(&__ppc__) || defined(&__ppc64__) || defined(&__i386__) || defined(&__x86_64__))) {
    }
    if(defined(&__cplusplus)) {
	eval 'sub GSSAPI_CPP_START () { &extern "C" {;}' unless defined(&GSSAPI_CPP_START);
	eval 'sub GSSAPI_CPP_END () {};}' unless defined(&GSSAPI_CPP_END);
    } else {
	eval 'sub GSSAPI_CPP_START () {1;}' unless defined(&GSSAPI_CPP_START);
	eval 'sub GSSAPI_CPP_END () {1;}' unless defined(&GSSAPI_CPP_END);
    }
    if(defined(&_WIN32)) {
	eval 'sub GSSAPI_CALLCONV () { &__stdcall;}' unless defined(&GSSAPI_CALLCONV);
    } else {
	eval 'sub GSSAPI_CALLCONV () {1;}' unless defined(&GSSAPI_CALLCONV);
    }
    eval 'sub GSS_C_DELEG_FLAG () {1;}' unless defined(&GSS_C_DELEG_FLAG);
    eval 'sub GSS_C_MUTUAL_FLAG () {2;}' unless defined(&GSS_C_MUTUAL_FLAG);
    eval 'sub GSS_C_REPLAY_FLAG () {4;}' unless defined(&GSS_C_REPLAY_FLAG);
    eval 'sub GSS_C_SEQUENCE_FLAG () {8;}' unless defined(&GSS_C_SEQUENCE_FLAG);
    eval 'sub GSS_C_CONF_FLAG () {16;}' unless defined(&GSS_C_CONF_FLAG);
    eval 'sub GSS_C_INTEG_FLAG () {32;}' unless defined(&GSS_C_INTEG_FLAG);
    eval 'sub GSS_C_ANON_FLAG () {64;}' unless defined(&GSS_C_ANON_FLAG);
    eval 'sub GSS_C_PROT_READY_FLAG () {128;}' unless defined(&GSS_C_PROT_READY_FLAG);
    eval 'sub GSS_C_TRANS_FLAG () {256;}' unless defined(&GSS_C_TRANS_FLAG);
    eval 'sub GSS_C_DCE_STYLE () {4096;}' unless defined(&GSS_C_DCE_STYLE);
    eval 'sub GSS_C_IDENTIFY_FLAG () {8192;}' unless defined(&GSS_C_IDENTIFY_FLAG);
    eval 'sub GSS_C_EXTENDED_ERROR_FLAG () {16384;}' unless defined(&GSS_C_EXTENDED_ERROR_FLAG);
    eval 'sub GSS_C_DELEG_POLICY_FLAG () {32768;}' unless defined(&GSS_C_DELEG_POLICY_FLAG);
    eval 'sub GSS_C_BOTH () {0;}' unless defined(&GSS_C_BOTH);
    eval 'sub GSS_C_INITIATE () {1;}' unless defined(&GSS_C_INITIATE);
    eval 'sub GSS_C_ACCEPT () {2;}' unless defined(&GSS_C_ACCEPT);
    eval 'sub GSS_C_GSS_CODE () {1;}' unless defined(&GSS_C_GSS_CODE);
    eval 'sub GSS_C_MECH_CODE () {2;}' unless defined(&GSS_C_MECH_CODE);
    eval 'sub GSS_C_AF_UNSPEC () {0;}' unless defined(&GSS_C_AF_UNSPEC);
    eval 'sub GSS_C_AF_LOCAL () {1;}' unless defined(&GSS_C_AF_LOCAL);
    eval 'sub GSS_C_AF_INET () {2;}' unless defined(&GSS_C_AF_INET);
    eval 'sub GSS_C_AF_IMPLINK () {3;}' unless defined(&GSS_C_AF_IMPLINK);
    eval 'sub GSS_C_AF_PUP () {4;}' unless defined(&GSS_C_AF_PUP);
    eval 'sub GSS_C_AF_CHAOS () {5;}' unless defined(&GSS_C_AF_CHAOS);
    eval 'sub GSS_C_AF_NS () {6;}' unless defined(&GSS_C_AF_NS);
    eval 'sub GSS_C_AF_NBS () {7;}' unless defined(&GSS_C_AF_NBS);
    eval 'sub GSS_C_AF_ECMA () {8;}' unless defined(&GSS_C_AF_ECMA);
    eval 'sub GSS_C_AF_DATAKIT () {9;}' unless defined(&GSS_C_AF_DATAKIT);
    eval 'sub GSS_C_AF_CCITT () {10;}' unless defined(&GSS_C_AF_CCITT);
    eval 'sub GSS_C_AF_SNA () {11;}' unless defined(&GSS_C_AF_SNA);
    eval 'sub GSS_C_AF_DECnet () {12;}' unless defined(&GSS_C_AF_DECnet);
    eval 'sub GSS_C_AF_DLI () {13;}' unless defined(&GSS_C_AF_DLI);
    eval 'sub GSS_C_AF_LAT () {14;}' unless defined(&GSS_C_AF_LAT);
    eval 'sub GSS_C_AF_HYLINK () {15;}' unless defined(&GSS_C_AF_HYLINK);
    eval 'sub GSS_C_AF_APPLETALK () {16;}' unless defined(&GSS_C_AF_APPLETALK);
    eval 'sub GSS_C_AF_BSC () {17;}' unless defined(&GSS_C_AF_BSC);
    eval 'sub GSS_C_AF_DSS () {18;}' unless defined(&GSS_C_AF_DSS);
    eval 'sub GSS_C_AF_OSI () {19;}' unless defined(&GSS_C_AF_OSI);
    eval 'sub GSS_C_AF_X25 () {21;}' unless defined(&GSS_C_AF_X25);
    eval 'sub GSS_C_AF_INET6 () {24;}' unless defined(&GSS_C_AF_INET6);
    eval 'sub GSS_C_AF_NULLADDR () {255;}' unless defined(&GSS_C_AF_NULLADDR);
    eval 'sub GSS_C_NO_NAME () {(( &gss_name_t) 0);}' unless defined(&GSS_C_NO_NAME);
    eval 'sub GSS_C_NO_BUFFER () {(( &gss_buffer_t) 0);}' unless defined(&GSS_C_NO_BUFFER);
    eval 'sub GSS_C_NO_BUFFER_SET () {(( &gss_buffer_set_t) 0);}' unless defined(&GSS_C_NO_BUFFER_SET);
    eval 'sub GSS_C_NO_OID () {(( &gss_OID) 0);}' unless defined(&GSS_C_NO_OID);
    eval 'sub GSS_C_NO_OID_SET () {(( &gss_OID_set) 0);}' unless defined(&GSS_C_NO_OID_SET);
    eval 'sub GSS_C_NO_CONTEXT () {(( &gss_ctx_id_t) 0);}' unless defined(&GSS_C_NO_CONTEXT);
    eval 'sub GSS_C_NO_CREDENTIAL () {(( &gss_cred_id_t) 0);}' unless defined(&GSS_C_NO_CREDENTIAL);
    eval 'sub GSS_C_NO_CHANNEL_BINDINGS () {(( &gss_channel_bindings_t) 0);}' unless defined(&GSS_C_NO_CHANNEL_BINDINGS);
    eval 'sub GSS_C_EMPTY_BUFFER () {{0,  &NULL};}' unless defined(&GSS_C_EMPTY_BUFFER);
    eval 'sub GSS_C_NO_IOV_BUFFER () {(( &gss_iov_buffer_t)0);}' unless defined(&GSS_C_NO_IOV_BUFFER);
    eval 'sub GSS_C_NULL_OID () { &GSS_C_NO_OID;}' unless defined(&GSS_C_NULL_OID);
    eval 'sub GSS_C_NULL_OID_SET () { &GSS_C_NO_OID_SET;}' unless defined(&GSS_C_NULL_OID_SET);
    eval 'sub GSS_C_QOP_DEFAULT () {0;}' unless defined(&GSS_C_QOP_DEFAULT);
    eval 'sub GSS_KRB5_CONF_C_QOP_DES () {0x100;}' unless defined(&GSS_KRB5_CONF_C_QOP_DES);
    eval 'sub GSS_KRB5_CONF_C_QOP_DES3_KD () {0x200;}' unless defined(&GSS_KRB5_CONF_C_QOP_DES3_KD);
    eval 'sub GSS_C_INDEFINITE () {0xffffffff;}' unless defined(&GSS_C_INDEFINITE);
    eval 'sub GSS_IOV_BUFFER_TYPE_EMPTY () {0;}' unless defined(&GSS_IOV_BUFFER_TYPE_EMPTY);
    eval 'sub GSS_IOV_BUFFER_TYPE_DATA () {1;}' unless defined(&GSS_IOV_BUFFER_TYPE_DATA);
    eval 'sub GSS_IOV_BUFFER_TYPE_HEADER () {2;}' unless defined(&GSS_IOV_BUFFER_TYPE_HEADER);
    eval 'sub GSS_IOV_BUFFER_TYPE_MECH_PARAMS () {3;}' unless defined(&GSS_IOV_BUFFER_TYPE_MECH_PARAMS);
    eval 'sub GSS_IOV_BUFFER_TYPE_TRAILER () {7;}' unless defined(&GSS_IOV_BUFFER_TYPE_TRAILER);
    eval 'sub GSS_IOV_BUFFER_TYPE_PADDING () {9;}' unless defined(&GSS_IOV_BUFFER_TYPE_PADDING);
    eval 'sub GSS_IOV_BUFFER_TYPE_STREAM () {10;}' unless defined(&GSS_IOV_BUFFER_TYPE_STREAM);
    eval 'sub GSS_IOV_BUFFER_TYPE_SIGN_ONLY () {11;}' unless defined(&GSS_IOV_BUFFER_TYPE_SIGN_ONLY);
    eval 'sub GSS_IOV_BUFFER_TYPE_FLAG_MASK () {0xffff0000;}' unless defined(&GSS_IOV_BUFFER_TYPE_FLAG_MASK);
    eval 'sub GSS_IOV_BUFFER_FLAG_ALLOCATE () {0x10000;}' unless defined(&GSS_IOV_BUFFER_FLAG_ALLOCATE);
    eval 'sub GSS_IOV_BUFFER_FLAG_ALLOCATED () {0x20000;}' unless defined(&GSS_IOV_BUFFER_FLAG_ALLOCATED);
    eval 'sub GSS_IOV_BUFFER_TYPE_FLAG_ALLOCATE () {0x10000;}' unless defined(&GSS_IOV_BUFFER_TYPE_FLAG_ALLOCATE);
    eval 'sub GSS_IOV_BUFFER_TYPE_FLAG_ALLOCATED () {0x20000;}' unless defined(&GSS_IOV_BUFFER_TYPE_FLAG_ALLOCATED);
    eval 'sub GSS_IOV_BUFFER_TYPE {
        my($_t) = @_;
	    eval q((($_t) & ~ &GSS_IOV_BUFFER_TYPE_FLAG_MASK));
    }' unless defined(&GSS_IOV_BUFFER_TYPE);
    eval 'sub GSS_IOV_BUFFER_FLAGS {
        my($_t) = @_;
	    eval q((($_t) &  &GSS_IOV_BUFFER_TYPE_FLAG_MASK));
    }' unless defined(&GSS_IOV_BUFFER_FLAGS);
    require 'gssapi/gssapi_oid.ph';
    eval 'sub GSS_C_NT_USER_NAME () {(& &__gss_c_nt_user_name_oid_desc);}' unless defined(&GSS_C_NT_USER_NAME);
    eval 'sub GSS_C_NT_MACHINE_UID_NAME () {(& &__gss_c_nt_machine_uid_name_oid_desc);}' unless defined(&GSS_C_NT_MACHINE_UID_NAME);
    eval 'sub GSS_C_NT_STRING_UID_NAME () {(& &__gss_c_nt_string_uid_name_oid_desc);}' unless defined(&GSS_C_NT_STRING_UID_NAME);
    eval 'sub GSS_C_NT_HOSTBASED_SERVICE_X () {(& &__gss_c_nt_hostbased_service_x_oid_desc);}' unless defined(&GSS_C_NT_HOSTBASED_SERVICE_X);
    eval 'sub GSS_C_NT_HOSTBASED_SERVICE () {(& &__gss_c_nt_hostbased_service_oid_desc);}' unless defined(&GSS_C_NT_HOSTBASED_SERVICE);
    eval 'sub GSS_C_NT_ANONYMOUS () {(& &__gss_c_nt_anonymous_oid_desc);}' unless defined(&GSS_C_NT_ANONYMOUS);
    eval 'sub GSS_C_NT_EXPORT_NAME () {(& &__gss_c_nt_export_name_oid_desc);}' unless defined(&GSS_C_NT_EXPORT_NAME);
    eval 'sub GSS_S_COMPLETE () {0;}' unless defined(&GSS_S_COMPLETE);
    eval 'sub GSS_C_CALLING_ERROR_OFFSET () {24;}' unless defined(&GSS_C_CALLING_ERROR_OFFSET);
    eval 'sub GSS_C_ROUTINE_ERROR_OFFSET () {16;}' unless defined(&GSS_C_ROUTINE_ERROR_OFFSET);
    eval 'sub GSS_C_SUPPLEMENTARY_OFFSET () {0;}' unless defined(&GSS_C_SUPPLEMENTARY_OFFSET);
    eval 'sub GSS_C_CALLING_ERROR_MASK () {0377;}' unless defined(&GSS_C_CALLING_ERROR_MASK);
    eval 'sub GSS_C_ROUTINE_ERROR_MASK () {0377;}' unless defined(&GSS_C_ROUTINE_ERROR_MASK);
    eval 'sub GSS_C_SUPPLEMENTARY_MASK () {0177777;}' unless defined(&GSS_C_SUPPLEMENTARY_MASK);
    eval 'sub GSS_CALLING_ERROR {
        my($x) = @_;
	    eval q(($x & ( &GSS_C_CALLING_ERROR_MASK <<  &GSS_C_CALLING_ERROR_OFFSET)));
    }' unless defined(&GSS_CALLING_ERROR);
    eval 'sub GSS_ROUTINE_ERROR {
        my($x) = @_;
	    eval q(($x & ( &GSS_C_ROUTINE_ERROR_MASK <<  &GSS_C_ROUTINE_ERROR_OFFSET)));
    }' unless defined(&GSS_ROUTINE_ERROR);
    eval 'sub GSS_SUPPLEMENTARY_INFO {
        my($x) = @_;
	    eval q(($x & ( &GSS_C_SUPPLEMENTARY_MASK <<  &GSS_C_SUPPLEMENTARY_OFFSET)));
    }' unless defined(&GSS_SUPPLEMENTARY_INFO);
    eval 'sub GSS_ERROR {
        my($x) = @_;
	    eval q(($x & (( &GSS_C_CALLING_ERROR_MASK <<  &GSS_C_CALLING_ERROR_OFFSET) | ( &GSS_C_ROUTINE_ERROR_MASK <<  &GSS_C_ROUTINE_ERROR_OFFSET))));
    }' unless defined(&GSS_ERROR);
    eval 'sub GSS_S_CALL_INACCESSIBLE_READ () {(1 <<  &GSS_C_CALLING_ERROR_OFFSET);}' unless defined(&GSS_S_CALL_INACCESSIBLE_READ);
    eval 'sub GSS_S_CALL_INACCESSIBLE_WRITE () {(2 <<  &GSS_C_CALLING_ERROR_OFFSET);}' unless defined(&GSS_S_CALL_INACCESSIBLE_WRITE);
    eval 'sub GSS_S_CALL_BAD_STRUCTURE () {(3 <<  &GSS_C_CALLING_ERROR_OFFSET);}' unless defined(&GSS_S_CALL_BAD_STRUCTURE);
    eval 'sub GSS_S_BAD_MECH () {(1 <<  &GSS_C_ROUTINE_ERROR_OFFSET);}' unless defined(&GSS_S_BAD_MECH);
    eval 'sub GSS_S_BAD_NAME () {(2 <<  &GSS_C_ROUTINE_ERROR_OFFSET);}' unless defined(&GSS_S_BAD_NAME);
    eval 'sub GSS_S_BAD_NAMETYPE () {(3 <<  &GSS_C_ROUTINE_ERROR_OFFSET);}' unless defined(&GSS_S_BAD_NAMETYPE);
    eval 'sub GSS_S_BAD_BINDINGS () {(4 <<  &GSS_C_ROUTINE_ERROR_OFFSET);}' unless defined(&GSS_S_BAD_BINDINGS);
    eval 'sub GSS_S_BAD_STATUS () {(5 <<  &GSS_C_ROUTINE_ERROR_OFFSET);}' unless defined(&GSS_S_BAD_STATUS);
    eval 'sub GSS_S_BAD_SIG () {(6 <<  &GSS_C_ROUTINE_ERROR_OFFSET);}' unless defined(&GSS_S_BAD_SIG);
    eval 'sub GSS_S_BAD_MIC () { &GSS_S_BAD_SIG;}' unless defined(&GSS_S_BAD_MIC);
    eval 'sub GSS_S_NO_CRED () {(7 <<  &GSS_C_ROUTINE_ERROR_OFFSET);}' unless defined(&GSS_S_NO_CRED);
    eval 'sub GSS_S_NO_CONTEXT () {(8 <<  &GSS_C_ROUTINE_ERROR_OFFSET);}' unless defined(&GSS_S_NO_CONTEXT);
    eval 'sub GSS_S_DEFECTIVE_TOKEN () {(9 <<  &GSS_C_ROUTINE_ERROR_OFFSET);}' unless defined(&GSS_S_DEFECTIVE_TOKEN);
    eval 'sub GSS_S_DEFECTIVE_CREDENTIAL () {(10 <<  &GSS_C_ROUTINE_ERROR_OFFSET);}' unless defined(&GSS_S_DEFECTIVE_CREDENTIAL);
    eval 'sub GSS_S_CREDENTIALS_EXPIRED () {(11 <<  &GSS_C_ROUTINE_ERROR_OFFSET);}' unless defined(&GSS_S_CREDENTIALS_EXPIRED);
    eval 'sub GSS_S_CONTEXT_EXPIRED () {(12 <<  &GSS_C_ROUTINE_ERROR_OFFSET);}' unless defined(&GSS_S_CONTEXT_EXPIRED);
    eval 'sub GSS_S_FAILURE () {(13 <<  &GSS_C_ROUTINE_ERROR_OFFSET);}' unless defined(&GSS_S_FAILURE);
    eval 'sub GSS_S_BAD_QOP () {(14 <<  &GSS_C_ROUTINE_ERROR_OFFSET);}' unless defined(&GSS_S_BAD_QOP);
    eval 'sub GSS_S_UNAUTHORIZED () {(15 <<  &GSS_C_ROUTINE_ERROR_OFFSET);}' unless defined(&GSS_S_UNAUTHORIZED);
    eval 'sub GSS_S_UNAVAILABLE () {(16 <<  &GSS_C_ROUTINE_ERROR_OFFSET);}' unless defined(&GSS_S_UNAVAILABLE);
    eval 'sub GSS_S_DUPLICATE_ELEMENT () {(17 <<  &GSS_C_ROUTINE_ERROR_OFFSET);}' unless defined(&GSS_S_DUPLICATE_ELEMENT);
    eval 'sub GSS_S_NAME_NOT_MN () {(18 <<  &GSS_C_ROUTINE_ERROR_OFFSET);}' unless defined(&GSS_S_NAME_NOT_MN);
    eval 'sub GSS_S_BAD_MECH_ATTR () {(19 <<  &GSS_C_ROUTINE_ERROR_OFFSET);}' unless defined(&GSS_S_BAD_MECH_ATTR);
    eval 'sub GSS_S_CRED_UNAVAIL () { &GSS_S_FAILURE;}' unless defined(&GSS_S_CRED_UNAVAIL);
    eval 'sub GSS_S_CONTINUE_NEEDED () {(1 << ( &GSS_C_SUPPLEMENTARY_OFFSET + 0));}' unless defined(&GSS_S_CONTINUE_NEEDED);
    eval 'sub GSS_S_DUPLICATE_TOKEN () {(1 << ( &GSS_C_SUPPLEMENTARY_OFFSET + 1));}' unless defined(&GSS_S_DUPLICATE_TOKEN);
    eval 'sub GSS_S_OLD_TOKEN () {(1 << ( &GSS_C_SUPPLEMENTARY_OFFSET + 2));}' unless defined(&GSS_S_OLD_TOKEN);
    eval 'sub GSS_S_UNSEQ_TOKEN () {(1 << ( &GSS_C_SUPPLEMENTARY_OFFSET + 3));}' unless defined(&GSS_S_UNSEQ_TOKEN);
    eval 'sub GSS_S_GAP_TOKEN () {(1 << ( &GSS_C_SUPPLEMENTARY_OFFSET + 4));}' unless defined(&GSS_S_GAP_TOKEN);
    eval 'sub GSS_C_OPTION_MASK () {0xffff;}' unless defined(&GSS_C_OPTION_MASK);
    eval 'sub GSS_C_CRED_NO_UI () {0x10000;}' unless defined(&GSS_C_CRED_NO_UI);
    eval 'sub GSS_C_PRF_KEY_FULL () {0;}' unless defined(&GSS_C_PRF_KEY_FULL);
    eval 'sub GSS_C_PRF_KEY_PARTIAL () {1;}' unless defined(&GSS_C_PRF_KEY_PARTIAL);
    eval 'sub GSS_C_ATTR_STREAM_SIZES () {(& &__gss_c_attr_stream_sizes_oid_desc);}' unless defined(&GSS_C_ATTR_STREAM_SIZES);
    eval 'sub GSS_C_ATTR_LOCAL_LOGIN_USER () {(& &__gss_c_attr_local_login_user);}' unless defined(&GSS_C_ATTR_LOCAL_LOGIN_USER);
    if(defined(&__APPLE__)  && (defined(&__ppc__) || defined(&__ppc64__) || defined(&__i386__) || defined(&__x86_64__))) {
    }
    undef(&GSSAPI_DEPRECATED_FUNCTION) if defined(&GSSAPI_DEPRECATED_FUNCTION);
}
1;
