require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETINET6_IN6_PCB_H_)) {
    eval 'sub _NETINET6_IN6_PCB_H_ () {1;}' unless defined(&_NETINET6_IN6_PCB_H_);
    require 'sys/queue.ph';
    require 'netinet/in_pcb_hdr.ph';
    require 'netinet/ip6.ph';
    eval 'sub in6p_hash () { ($in6p_head->{inph_hash});}' unless defined(&in6p_hash);
    eval 'sub in6p_queue () { ($in6p_head->{inph_queue});}' unless defined(&in6p_queue);
    eval 'sub in6p_af () { ($in6p_head->{inph_af});}' unless defined(&in6p_af);
    eval 'sub in6p_ppcb () { ($in6p_head->{inph_ppcb});}' unless defined(&in6p_ppcb);
    eval 'sub in6p_state () { ($in6p_head->{inph_state});}' unless defined(&in6p_state);
    eval 'sub in6p_portalgo () { ($in6p_head->{inph_portalgo});}' unless defined(&in6p_portalgo);
    eval 'sub in6p_socket () { ($in6p_head->{inph_socket});}' unless defined(&in6p_socket);
    eval 'sub in6p_table () { ($in6p_head->{inph_table});}' unless defined(&in6p_table);
    eval 'sub in6p_sp () { ($in6p_head->{inph_sp});}' unless defined(&in6p_sp);
    eval 'sub in6p_faddr () { ($in6p_ip6->{ip6_dst});}' unless defined(&in6p_faddr);
    eval 'sub in6p_laddr () { ($in6p_ip6->{ip6_src});}' unless defined(&in6p_laddr);
    eval 'sub in6p_lock {
        my($in6p) = @_;
	    eval q( &solock(($in6p)-> &in6p_socket));
    }' unless defined(&in6p_lock);
    eval 'sub in6p_unlock {
        my($in6p) = @_;
	    eval q( &sounlock(($in6p)-> &in6p_socket));
    }' unless defined(&in6p_unlock);
    eval 'sub in6p_locked {
        my($in6p) = @_;
	    eval q( &solocked(($in6p)-> &in6p_socket));
    }' unless defined(&in6p_locked);
    eval 'sub IN6P_ATTACHED () { &INP_ATTACHED;}' unless defined(&IN6P_ATTACHED);
    eval 'sub IN6P_BOUND () { &INP_BOUND;}' unless defined(&IN6P_BOUND);
    eval 'sub IN6P_CONNECTED () { &INP_CONNECTED;}' unless defined(&IN6P_CONNECTED);
    eval 'sub IN6P_RECVOPTS () {0x1000;}' unless defined(&IN6P_RECVOPTS);
    eval 'sub IN6P_RECVRETOPTS () {0x2000;}' unless defined(&IN6P_RECVRETOPTS);
    eval 'sub IN6P_RECVDSTADDR () {0x4000;}' unless defined(&IN6P_RECVDSTADDR);
    eval 'sub IN6P_IPV6_V6ONLY () {0x8000;}' unless defined(&IN6P_IPV6_V6ONLY);
    eval 'sub IN6P_PKTINFO () {0x10000;}' unless defined(&IN6P_PKTINFO);
    eval 'sub IN6P_HOPLIMIT () {0x20000;}' unless defined(&IN6P_HOPLIMIT);
    eval 'sub IN6P_HOPOPTS () {0x40000;}' unless defined(&IN6P_HOPOPTS);
    eval 'sub IN6P_DSTOPTS () {0x80000;}' unless defined(&IN6P_DSTOPTS);
    eval 'sub IN6P_RTHDR () {0x100000;}' unless defined(&IN6P_RTHDR);
    eval 'sub IN6P_RTHDRDSTOPTS () {0x200000;}' unless defined(&IN6P_RTHDRDSTOPTS);
    eval 'sub IN6P_TCLASS () {0x400000;}' unless defined(&IN6P_TCLASS);
    eval 'sub IN6P_HIGHPORT () {0x1000000;}' unless defined(&IN6P_HIGHPORT);
    eval 'sub IN6P_LOWPORT () {0x2000000;}' unless defined(&IN6P_LOWPORT);
    eval 'sub IN6P_ANONPORT () {0x4000000;}' unless defined(&IN6P_ANONPORT);
    eval 'sub IN6P_FAITH () {0x8000000;}' unless defined(&IN6P_FAITH);
    eval 'sub IN6P_ESPINUDP () { &INP_ESPINUDP;}' unless defined(&IN6P_ESPINUDP);
    eval 'sub IN6P_RFC2292 () {0x40000000;}' unless defined(&IN6P_RFC2292);
    eval 'sub IN6P_MTU () {0x80000000;}' unless defined(&IN6P_MTU);
    eval 'sub IN6P_CONTROLOPTS () {( &IN6P_PKTINFO| &IN6P_HOPLIMIT| &IN6P_HOPOPTS|  &IN6P_DSTOPTS| &IN6P_RTHDR| &IN6P_RTHDRDSTOPTS|  &IN6P_TCLASS| &IN6P_RFC2292|  &IN6P_MTU);}' unless defined(&IN6P_CONTROLOPTS);
    if(defined(&_KERNEL)) {
	eval 'sub IN6_HASH {
	    my($faddr, $fport, $laddr, $lport) = @_;
    	    eval q(((($faddr)-> $s6_addr32[0] ^ ($faddr)-> $s6_addr32[1] ^ ($faddr)-> $s6_addr32[2] ^ ($faddr)-> $s6_addr32[3] ^ ($laddr)-> $s6_addr32[0] ^ ($laddr)-> $s6_addr32[1] ^ ($laddr)-> $s6_addr32[2] ^ ($laddr)-> $s6_addr32[3]) + ($fport) + ($lport)));
	}' unless defined(&IN6_HASH);
	eval 'sub sotoin6pcb {
	    my($so) = @_;
    	    eval q((($so)-> &so_pcb));
	}' unless defined(&sotoin6pcb);
    }
}
1;
