require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&HEADER_ERR_H)) {
    eval 'sub HEADER_ERR_H () {1;}' unless defined(&HEADER_ERR_H);
    require 'openssl/e_os2.ph';
    unless(defined(&OPENSSL_NO_STDIO)) {
	require 'stdio.ph';
	require 'stdlib.ph';
    }
    require 'openssl/ossl_typ.ph';
    require 'openssl/bio.ph';
    require 'openssl/lhash.ph';
    if(defined(&__cplusplus)) {
    }
    unless(defined(&OPENSSL_NO_ERR)) {
	eval 'sub ERR_PUT_error {
	    my($a,$b,$c,$d,$e) = @_;
    	    eval q( &ERR_put_error($a,$b,$c,$d,$e));
	}' unless defined(&ERR_PUT_error);
    } else {
	eval 'sub ERR_PUT_error {
	    my($a,$b,$c,$d,$e) = @_;
    	    eval q( &ERR_put_error($a,$b,$c, &NULL,0));
	}' unless defined(&ERR_PUT_error);
    }
    require 'errno.ph';
    eval 'sub ERR_TXT_MALLOCED () {0x1;}' unless defined(&ERR_TXT_MALLOCED);
    eval 'sub ERR_TXT_STRING () {0x2;}' unless defined(&ERR_TXT_STRING);
    eval 'sub ERR_FLAG_MARK () {0x1;}' unless defined(&ERR_FLAG_MARK);
    eval 'sub ERR_FLAG_CLEAR () {0x2;}' unless defined(&ERR_FLAG_CLEAR);
    eval 'sub ERR_NUM_ERRORS () {16;}' unless defined(&ERR_NUM_ERRORS);
    eval 'sub ERR_LIB_NONE () {1;}' unless defined(&ERR_LIB_NONE);
    eval 'sub ERR_LIB_SYS () {2;}' unless defined(&ERR_LIB_SYS);
    eval 'sub ERR_LIB_BN () {3;}' unless defined(&ERR_LIB_BN);
    eval 'sub ERR_LIB_RSA () {4;}' unless defined(&ERR_LIB_RSA);
    eval 'sub ERR_LIB_DH () {5;}' unless defined(&ERR_LIB_DH);
    eval 'sub ERR_LIB_EVP () {6;}' unless defined(&ERR_LIB_EVP);
    eval 'sub ERR_LIB_BUF () {7;}' unless defined(&ERR_LIB_BUF);
    eval 'sub ERR_LIB_OBJ () {8;}' unless defined(&ERR_LIB_OBJ);
    eval 'sub ERR_LIB_PEM () {9;}' unless defined(&ERR_LIB_PEM);
    eval 'sub ERR_LIB_DSA () {10;}' unless defined(&ERR_LIB_DSA);
    eval 'sub ERR_LIB_X509 () {11;}' unless defined(&ERR_LIB_X509);
    eval 'sub ERR_LIB_ASN1 () {13;}' unless defined(&ERR_LIB_ASN1);
    eval 'sub ERR_LIB_CONF () {14;}' unless defined(&ERR_LIB_CONF);
    eval 'sub ERR_LIB_CRYPTO () {15;}' unless defined(&ERR_LIB_CRYPTO);
    eval 'sub ERR_LIB_EC () {16;}' unless defined(&ERR_LIB_EC);
    eval 'sub ERR_LIB_SSL () {20;}' unless defined(&ERR_LIB_SSL);
    eval 'sub ERR_LIB_BIO () {32;}' unless defined(&ERR_LIB_BIO);
    eval 'sub ERR_LIB_PKCS7 () {33;}' unless defined(&ERR_LIB_PKCS7);
    eval 'sub ERR_LIB_X509V3 () {34;}' unless defined(&ERR_LIB_X509V3);
    eval 'sub ERR_LIB_PKCS12 () {35;}' unless defined(&ERR_LIB_PKCS12);
    eval 'sub ERR_LIB_RAND () {36;}' unless defined(&ERR_LIB_RAND);
    eval 'sub ERR_LIB_DSO () {37;}' unless defined(&ERR_LIB_DSO);
    eval 'sub ERR_LIB_ENGINE () {38;}' unless defined(&ERR_LIB_ENGINE);
    eval 'sub ERR_LIB_OCSP () {39;}' unless defined(&ERR_LIB_OCSP);
    eval 'sub ERR_LIB_UI () {40;}' unless defined(&ERR_LIB_UI);
    eval 'sub ERR_LIB_COMP () {41;}' unless defined(&ERR_LIB_COMP);
    eval 'sub ERR_LIB_ECDSA () {42;}' unless defined(&ERR_LIB_ECDSA);
    eval 'sub ERR_LIB_ECDH () {43;}' unless defined(&ERR_LIB_ECDH);
    eval 'sub ERR_LIB_OSSL_STORE () {44;}' unless defined(&ERR_LIB_OSSL_STORE);
    eval 'sub ERR_LIB_FIPS () {45;}' unless defined(&ERR_LIB_FIPS);
    eval 'sub ERR_LIB_CMS () {46;}' unless defined(&ERR_LIB_CMS);
    eval 'sub ERR_LIB_TS () {47;}' unless defined(&ERR_LIB_TS);
    eval 'sub ERR_LIB_HMAC () {48;}' unless defined(&ERR_LIB_HMAC);
    eval 'sub ERR_LIB_CT () {50;}' unless defined(&ERR_LIB_CT);
    eval 'sub ERR_LIB_ASYNC () {51;}' unless defined(&ERR_LIB_ASYNC);
    eval 'sub ERR_LIB_KDF () {52;}' unless defined(&ERR_LIB_KDF);
    eval 'sub ERR_LIB_SM2 () {53;}' unless defined(&ERR_LIB_SM2);
    eval 'sub ERR_LIB_USER () {128;}' unless defined(&ERR_LIB_USER);
    eval 'sub SYSerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_SYS,($f),($r), &OPENSSL_FILE, &OPENSSL_LINE));
    }' unless defined(&SYSerr);
    eval 'sub BNerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_BN,($f),($r), &OPENSSL_FILE, &OPENSSL_LINE));
    }' unless defined(&BNerr);
    eval 'sub RSAerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_RSA,($f),($r), &OPENSSL_FILE, &OPENSSL_LINE));
    }' unless defined(&RSAerr);
    eval 'sub DHerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_DH,($f),($r), &OPENSSL_FILE, &OPENSSL_LINE));
    }' unless defined(&DHerr);
    eval 'sub EVPerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_EVP,($f),($r), &OPENSSL_FILE, &OPENSSL_LINE));
    }' unless defined(&EVPerr);
    eval 'sub BUFerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_BUF,($f),($r), &OPENSSL_FILE, &OPENSSL_LINE));
    }' unless defined(&BUFerr);
    eval 'sub OBJerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_OBJ,($f),($r), &OPENSSL_FILE, &OPENSSL_LINE));
    }' unless defined(&OBJerr);
    eval 'sub PEMerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_PEM,($f),($r), &OPENSSL_FILE, &OPENSSL_LINE));
    }' unless defined(&PEMerr);
    eval 'sub DSAerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_DSA,($f),($r), &OPENSSL_FILE, &OPENSSL_LINE));
    }' unless defined(&DSAerr);
    eval 'sub X509err {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_X509,($f),($r), &OPENSSL_FILE, &OPENSSL_LINE));
    }' unless defined(&X509err);
    eval 'sub ASN1err {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_ASN1,($f),($r), &OPENSSL_FILE, &OPENSSL_LINE));
    }' unless defined(&ASN1err);
    eval 'sub CONFerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_CONF,($f),($r), &OPENSSL_FILE, &OPENSSL_LINE));
    }' unless defined(&CONFerr);
    eval 'sub CRYPTOerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_CRYPTO,($f),($r), &OPENSSL_FILE, &OPENSSL_LINE));
    }' unless defined(&CRYPTOerr);
    eval 'sub ECerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_EC,($f),($r), &OPENSSL_FILE, &OPENSSL_LINE));
    }' unless defined(&ECerr);
    eval 'sub SSLerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_SSL,($f),($r), &OPENSSL_FILE, &OPENSSL_LINE));
    }' unless defined(&SSLerr);
    eval 'sub BIOerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_BIO,($f),($r), &OPENSSL_FILE, &OPENSSL_LINE));
    }' unless defined(&BIOerr);
    eval 'sub PKCS7err {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_PKCS7,($f),($r), &OPENSSL_FILE, &OPENSSL_LINE));
    }' unless defined(&PKCS7err);
    eval 'sub X509V3err {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_X509V3,($f),($r), &OPENSSL_FILE, &OPENSSL_LINE));
    }' unless defined(&X509V3err);
    eval 'sub PKCS12err {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_PKCS12,($f),($r), &OPENSSL_FILE, &OPENSSL_LINE));
    }' unless defined(&PKCS12err);
    eval 'sub RANDerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_RAND,($f),($r), &OPENSSL_FILE, &OPENSSL_LINE));
    }' unless defined(&RANDerr);
    eval 'sub DSOerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_DSO,($f),($r), &OPENSSL_FILE, &OPENSSL_LINE));
    }' unless defined(&DSOerr);
    eval 'sub ENGINEerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_ENGINE,($f),($r), &OPENSSL_FILE, &OPENSSL_LINE));
    }' unless defined(&ENGINEerr);
    eval 'sub OCSPerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_OCSP,($f),($r), &OPENSSL_FILE, &OPENSSL_LINE));
    }' unless defined(&OCSPerr);
    eval 'sub UIerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_UI,($f),($r), &OPENSSL_FILE, &OPENSSL_LINE));
    }' unless defined(&UIerr);
    eval 'sub COMPerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_COMP,($f),($r), &OPENSSL_FILE, &OPENSSL_LINE));
    }' unless defined(&COMPerr);
    eval 'sub ECDSAerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_ECDSA,($f),($r), &OPENSSL_FILE, &OPENSSL_LINE));
    }' unless defined(&ECDSAerr);
    eval 'sub ECDHerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_ECDH,($f),($r), &OPENSSL_FILE, &OPENSSL_LINE));
    }' unless defined(&ECDHerr);
    eval 'sub OSSL_STOREerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_OSSL_STORE,($f),($r), &OPENSSL_FILE, &OPENSSL_LINE));
    }' unless defined(&OSSL_STOREerr);
    eval 'sub FIPSerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_FIPS,($f),($r), &OPENSSL_FILE, &OPENSSL_LINE));
    }' unless defined(&FIPSerr);
    eval 'sub CMSerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_CMS,($f),($r), &OPENSSL_FILE, &OPENSSL_LINE));
    }' unless defined(&CMSerr);
    eval 'sub TSerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_TS,($f),($r), &OPENSSL_FILE, &OPENSSL_LINE));
    }' unless defined(&TSerr);
    eval 'sub HMACerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_HMAC,($f),($r), &OPENSSL_FILE, &OPENSSL_LINE));
    }' unless defined(&HMACerr);
    eval 'sub CTerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_CT,($f),($r), &OPENSSL_FILE, &OPENSSL_LINE));
    }' unless defined(&CTerr);
    eval 'sub ASYNCerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_ASYNC,($f),($r), &OPENSSL_FILE, &OPENSSL_LINE));
    }' unless defined(&ASYNCerr);
    eval 'sub KDFerr {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_KDF,($f),($r), &OPENSSL_FILE, &OPENSSL_LINE));
    }' unless defined(&KDFerr);
    eval 'sub SM2err {
        my($f,$r) = @_;
	    eval q( &ERR_PUT_error( &ERR_LIB_SM2,($f),($r), &OPENSSL_FILE, &OPENSSL_LINE));
    }' unless defined(&SM2err);
    eval 'sub ERR_PACK {
        my($l,$f,$r) = @_;
	    eval q(( (( & 0xff) << 24) | (( & 0xfff) << 12) | ((($r) & 0xfff) ) ));
    }' unless defined(&ERR_PACK);
    eval 'sub ERR_GET_LIB {
        my($l) = @_;
	    eval q(((($l) >> 24) & 0xff));
    }' unless defined(&ERR_GET_LIB);
    eval 'sub ERR_GET_FUNC {
        my($l) = @_;
	    eval q(((($l) >> 12) & 0xfff));
    }' unless defined(&ERR_GET_FUNC);
    eval 'sub ERR_GET_REASON {
        my($l) = @_;
	    eval q(( ($l) & 0xfff));
    }' unless defined(&ERR_GET_REASON);
    eval 'sub ERR_FATAL_ERROR {
        my($l) = @_;
	    eval q(( ($l) &  &ERR_R_FATAL));
    }' unless defined(&ERR_FATAL_ERROR);
    eval 'sub SYS_F_FOPEN () {1;}' unless defined(&SYS_F_FOPEN);
    eval 'sub SYS_F_CONNECT () {2;}' unless defined(&SYS_F_CONNECT);
    eval 'sub SYS_F_GETSERVBYNAME () {3;}' unless defined(&SYS_F_GETSERVBYNAME);
    eval 'sub SYS_F_SOCKET () {4;}' unless defined(&SYS_F_SOCKET);
    eval 'sub SYS_F_IOCTLSOCKET () {5;}' unless defined(&SYS_F_IOCTLSOCKET);
    eval 'sub SYS_F_BIND () {6;}' unless defined(&SYS_F_BIND);
    eval 'sub SYS_F_LISTEN () {7;}' unless defined(&SYS_F_LISTEN);
    eval 'sub SYS_F_ACCEPT () {8;}' unless defined(&SYS_F_ACCEPT);
    eval 'sub SYS_F_WSASTARTUP () {9;}' unless defined(&SYS_F_WSASTARTUP);
    eval 'sub SYS_F_OPENDIR () {10;}' unless defined(&SYS_F_OPENDIR);
    eval 'sub SYS_F_FREAD () {11;}' unless defined(&SYS_F_FREAD);
    eval 'sub SYS_F_GETADDRINFO () {12;}' unless defined(&SYS_F_GETADDRINFO);
    eval 'sub SYS_F_GETNAMEINFO () {13;}' unless defined(&SYS_F_GETNAMEINFO);
    eval 'sub SYS_F_SETSOCKOPT () {14;}' unless defined(&SYS_F_SETSOCKOPT);
    eval 'sub SYS_F_GETSOCKOPT () {15;}' unless defined(&SYS_F_GETSOCKOPT);
    eval 'sub SYS_F_GETSOCKNAME () {16;}' unless defined(&SYS_F_GETSOCKNAME);
    eval 'sub SYS_F_GETHOSTBYNAME () {17;}' unless defined(&SYS_F_GETHOSTBYNAME);
    eval 'sub SYS_F_FFLUSH () {18;}' unless defined(&SYS_F_FFLUSH);
    eval 'sub SYS_F_OPEN () {19;}' unless defined(&SYS_F_OPEN);
    eval 'sub SYS_F_CLOSE () {20;}' unless defined(&SYS_F_CLOSE);
    eval 'sub SYS_F_IOCTL () {21;}' unless defined(&SYS_F_IOCTL);
    eval 'sub SYS_F_STAT () {22;}' unless defined(&SYS_F_STAT);
    eval 'sub SYS_F_FCNTL () {23;}' unless defined(&SYS_F_FCNTL);
    eval 'sub SYS_F_FSTAT () {24;}' unless defined(&SYS_F_FSTAT);
    eval 'sub ERR_R_SYS_LIB () { &ERR_LIB_SYS;}' unless defined(&ERR_R_SYS_LIB);
    eval 'sub ERR_R_BN_LIB () { &ERR_LIB_BN;}' unless defined(&ERR_R_BN_LIB);
    eval 'sub ERR_R_RSA_LIB () { &ERR_LIB_RSA;}' unless defined(&ERR_R_RSA_LIB);
    eval 'sub ERR_R_DH_LIB () { &ERR_LIB_DH;}' unless defined(&ERR_R_DH_LIB);
    eval 'sub ERR_R_EVP_LIB () { &ERR_LIB_EVP;}' unless defined(&ERR_R_EVP_LIB);
    eval 'sub ERR_R_BUF_LIB () { &ERR_LIB_BUF;}' unless defined(&ERR_R_BUF_LIB);
    eval 'sub ERR_R_OBJ_LIB () { &ERR_LIB_OBJ;}' unless defined(&ERR_R_OBJ_LIB);
    eval 'sub ERR_R_PEM_LIB () { &ERR_LIB_PEM;}' unless defined(&ERR_R_PEM_LIB);
    eval 'sub ERR_R_DSA_LIB () { &ERR_LIB_DSA;}' unless defined(&ERR_R_DSA_LIB);
    eval 'sub ERR_R_X509_LIB () { &ERR_LIB_X509;}' unless defined(&ERR_R_X509_LIB);
    eval 'sub ERR_R_ASN1_LIB () { &ERR_LIB_ASN1;}' unless defined(&ERR_R_ASN1_LIB);
    eval 'sub ERR_R_EC_LIB () { &ERR_LIB_EC;}' unless defined(&ERR_R_EC_LIB);
    eval 'sub ERR_R_BIO_LIB () { &ERR_LIB_BIO;}' unless defined(&ERR_R_BIO_LIB);
    eval 'sub ERR_R_PKCS7_LIB () { &ERR_LIB_PKCS7;}' unless defined(&ERR_R_PKCS7_LIB);
    eval 'sub ERR_R_X509V3_LIB () { &ERR_LIB_X509V3;}' unless defined(&ERR_R_X509V3_LIB);
    eval 'sub ERR_R_ENGINE_LIB () { &ERR_LIB_ENGINE;}' unless defined(&ERR_R_ENGINE_LIB);
    eval 'sub ERR_R_UI_LIB () { &ERR_LIB_UI;}' unless defined(&ERR_R_UI_LIB);
    eval 'sub ERR_R_ECDSA_LIB () { &ERR_LIB_ECDSA;}' unless defined(&ERR_R_ECDSA_LIB);
    eval 'sub ERR_R_OSSL_STORE_LIB () { &ERR_LIB_OSSL_STORE;}' unless defined(&ERR_R_OSSL_STORE_LIB);
    eval 'sub ERR_R_NESTED_ASN1_ERROR () {58;}' unless defined(&ERR_R_NESTED_ASN1_ERROR);
    eval 'sub ERR_R_MISSING_ASN1_EOS () {63;}' unless defined(&ERR_R_MISSING_ASN1_EOS);
    eval 'sub ERR_R_FATAL () {64;}' unless defined(&ERR_R_FATAL);
    eval 'sub ERR_R_MALLOC_FAILURE () {(1| &ERR_R_FATAL);}' unless defined(&ERR_R_MALLOC_FAILURE);
    eval 'sub ERR_R_SHOULD_NOT_HAVE_BEEN_CALLED () {(2| &ERR_R_FATAL);}' unless defined(&ERR_R_SHOULD_NOT_HAVE_BEEN_CALLED);
    eval 'sub ERR_R_PASSED_NULL_PARAMETER () {(3| &ERR_R_FATAL);}' unless defined(&ERR_R_PASSED_NULL_PARAMETER);
    eval 'sub ERR_R_INTERNAL_ERROR () {(4| &ERR_R_FATAL);}' unless defined(&ERR_R_INTERNAL_ERROR);
    eval 'sub ERR_R_DISABLED () {(5| &ERR_R_FATAL);}' unless defined(&ERR_R_DISABLED);
    eval 'sub ERR_R_INIT_FAIL () {(6| &ERR_R_FATAL);}' unless defined(&ERR_R_INIT_FAIL);
    eval 'sub ERR_R_PASSED_INVALID_ARGUMENT () {(7);}' unless defined(&ERR_R_PASSED_INVALID_ARGUMENT);
    eval 'sub ERR_R_OPERATION_FAIL () {(8| &ERR_R_FATAL);}' unless defined(&ERR_R_OPERATION_FAIL);
    unless(defined(&OPENSSL_NO_STDIO)) {
    }
    if((defined(&OPENSSL_API_COMPAT) ? &OPENSSL_API_COMPAT : undef) < 0x10100000) {
	eval 'sub ERR_load_crypto_strings () {
	    eval q( &OPENSSL_init_crypto( &OPENSSL_INIT_LOAD_CRYPTO_STRINGS,  &NULL));
	}' unless defined(&ERR_load_crypto_strings);
	eval 'sub ERR_free_strings () {
	    eval q( &while(0)  &continue);
	}' unless defined(&ERR_free_strings);
    }
    if(defined(&__cplusplus)) {
    }
}
1;
