require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&HEADER_LHASH_H)) {
    eval 'sub HEADER_LHASH_H () {1;}' unless defined(&HEADER_LHASH_H);
    require 'openssl/e_os2.ph';
    require 'openssl/bio.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub DECLARE_LHASH_HASH_FN {
        my($name, $o_type) = @_;
	    eval q(\'unsigned long name\' &_LHASH_HASH( &const  &void *););
    }' unless defined(&DECLARE_LHASH_HASH_FN);
    eval 'sub IMPLEMENT_LHASH_HASH_FN {
        my($name, $o_type) = @_;
	    eval q(\'unsigned long name\' &_LHASH_HASH( &const  &void * &arg) {  &const $o_type * &a =  &arg;  &return $name &_hash( &a); });
    }' unless defined(&IMPLEMENT_LHASH_HASH_FN);
    eval 'sub LHASH_HASH_FN {
        my($name) = @_;
	    eval q($name &_LHASH_HASH);
    }' unless defined(&LHASH_HASH_FN);
    eval 'sub DECLARE_LHASH_COMP_FN {
        my($name, $o_type) = @_;
	    eval q(\'int\' $name &_LHASH_COMP( &const  &void *,  &const  &void *););
    }' unless defined(&DECLARE_LHASH_COMP_FN);
    eval 'sub IMPLEMENT_LHASH_COMP_FN {
        my($name, $o_type) = @_;
	    eval q(\'int\' $name &_LHASH_COMP( &const  &void * &arg1,  &const  &void * &arg2) {  &const $o_type * &a =  &arg1;  &const $o_type * &b =  &arg2;  &return $name &_cmp( &a, &b); });
    }' unless defined(&IMPLEMENT_LHASH_COMP_FN);
    eval 'sub LHASH_COMP_FN {
        my($name) = @_;
	    eval q($name &_LHASH_COMP);
    }' unless defined(&LHASH_COMP_FN);
    eval 'sub DECLARE_LHASH_DOALL_ARG_FN {
        my($name, $o_type, $a_type) = @_;
	    eval q( &void $name &_LHASH_DOALL_ARG( &void *,  &void *););
    }' unless defined(&DECLARE_LHASH_DOALL_ARG_FN);
    eval 'sub IMPLEMENT_LHASH_DOALL_ARG_FN {
        my($name, $o_type, $a_type) = @_;
	    eval q( &void $name &_LHASH_DOALL_ARG( &void * &arg1,  &void * &arg2) { $o_type * &a =  &arg1; $a_type * &b =  &arg2; $name &_doall_arg( &a,  &b); });
    }' unless defined(&IMPLEMENT_LHASH_DOALL_ARG_FN);
    eval 'sub LHASH_DOALL_ARG_FN {
        my($name) = @_;
	    eval q($name &_LHASH_DOALL_ARG);
    }' unless defined(&LHASH_DOALL_ARG_FN);
    eval 'sub LH_LOAD_MULT () {256;}' unless defined(&LH_LOAD_MULT);
    unless(defined(&OPENSSL_NO_STDIO)) {
    }
    if((defined(&OPENSSL_API_COMPAT) ? &OPENSSL_API_COMPAT : undef) < 0x10100000) {
	eval 'sub _LHASH () { &OPENSSL_LHASH;}' unless defined(&_LHASH);
	eval 'sub LHASH_NODE () { &OPENSSL_LH_NODE;}' unless defined(&LHASH_NODE);
	eval 'sub lh_error () { &OPENSSL_LH_error;}' unless defined(&lh_error);
	eval 'sub lh_new () { &OPENSSL_LH_new;}' unless defined(&lh_new);
	eval 'sub lh_free () { &OPENSSL_LH_free;}' unless defined(&lh_free);
	eval 'sub lh_insert () { &OPENSSL_LH_insert;}' unless defined(&lh_insert);
	eval 'sub lh_delete () { &OPENSSL_LH_delete;}' unless defined(&lh_delete);
	eval 'sub lh_retrieve () { &OPENSSL_LH_retrieve;}' unless defined(&lh_retrieve);
	eval 'sub lh_doall () { &OPENSSL_LH_doall;}' unless defined(&lh_doall);
	eval 'sub lh_doall_arg () { &OPENSSL_LH_doall_arg;}' unless defined(&lh_doall_arg);
	eval 'sub lh_strhash () { &OPENSSL_LH_strhash;}' unless defined(&lh_strhash);
	eval 'sub lh_num_items () { &OPENSSL_LH_num_items;}' unless defined(&lh_num_items);
	unless(defined(&OPENSSL_NO_STDIO)) {
	    eval 'sub lh_stats () { &OPENSSL_LH_stats;}' unless defined(&lh_stats);
	    eval 'sub lh_node_stats () { &OPENSSL_LH_node_stats;}' unless defined(&lh_node_stats);
	    eval 'sub lh_node_usage_stats () { &OPENSSL_LH_node_usage_stats;}' unless defined(&lh_node_usage_stats);
	}
	eval 'sub lh_stats_bio () { &OPENSSL_LH_stats_bio;}' unless defined(&lh_stats_bio);
	eval 'sub lh_node_stats_bio () { &OPENSSL_LH_node_stats_bio;}' unless defined(&lh_node_stats_bio);
	eval 'sub lh_node_usage_stats_bio () { &OPENSSL_LH_node_usage_stats_bio;}' unless defined(&lh_node_usage_stats_bio);
    }
    eval 'sub LHASH_OF {
        my($type) = @_;
	    eval q(\'struct lhash_st_\'$type);
    }' unless defined(&LHASH_OF);
    eval 'sub DEFINE_LHASH_OF {
        my($type) = @_;
	    eval q( &LHASH_OF($type) { \'union lh_\'$type &_dummy {  &void*  &d1; \'unsigned long d2\'; \'int\'  &d3; }  &dummy; };  &static  &ossl_unused  &ossl_inline  &LHASH_OF($type) * &lh_$type &_new( &unsigned long (* &hfn)( &const $type *),  &int (* &cfn)( &const $type *,  &const $type *)) {  &return ( &LHASH_OF($type) *)  &OPENSSL_LH_new(( &OPENSSL_LH_HASHFUNC) &hfn, ( &OPENSSL_LH_COMPFUNC) &cfn); }  &static  &ossl_unused  &ossl_inline  &void  &lh_$type &_free( &LHASH_OF($type) * &lh) {  &OPENSSL_LH_free(( &OPENSSL_LHASH *) &lh); }  &static  &ossl_unused  &ossl_inline $type * &lh_$type &_insert( &LHASH_OF($type) * &lh, $type * &d) {  &return ($type *) &OPENSSL_LH_insert(( &OPENSSL_LHASH *) &lh,  &d); }  &static  &ossl_unused  &ossl_inline $type * &lh_$type &_delete( &LHASH_OF($type) * &lh,  &const $type * &d) {  &return ($type *) &OPENSSL_LH_delete(( &OPENSSL_LHASH *) &lh,  &d); }  &static  &ossl_unused  &ossl_inline $type * &lh_$type &_retrieve( &LHASH_OF($type) * &lh,  &const $type * &d) {  &return ($type *) &OPENSSL_LH_retrieve(( &OPENSSL_LHASH *) &lh,  &d); }  &static  &ossl_unused  &ossl_inline \'int\'  &lh_$type &_error( &LHASH_OF($type) * &lh) {  &return  &OPENSSL_LH_error(( &OPENSSL_LHASH *) &lh); }  &static  &ossl_unused  &ossl_inline \'unsigned long lh_\'$type &_num_items( &LHASH_OF($type) * &lh) {  &return  &OPENSSL_LH_num_items(( &OPENSSL_LHASH *) &lh); }  &static  &ossl_unused  &ossl_inline  &void  &lh_$type &_node_stats_bio( &const  &LHASH_OF($type) * &lh,  &BIO * &out) {  &OPENSSL_LH_node_stats_bio(( &const  &OPENSSL_LHASH *) &lh,  &out); }  &static  &ossl_unused  &ossl_inline  &void  &lh_$type &_node_usage_stats_bio( &const  &LHASH_OF($type) * &lh,  &BIO * &out) {  &OPENSSL_LH_node_usage_stats_bio(( &const  &OPENSSL_LHASH *) &lh,  &out); }  &static  &ossl_unused  &ossl_inline  &void  &lh_$type &_stats_bio( &const  &LHASH_OF($type) * &lh,  &BIO * &out) {  &OPENSSL_LH_stats_bio(( &const  &OPENSSL_LHASH *) &lh,  &out); }  &static  &ossl_unused  &ossl_inline \'unsigned long lh_\'$type &_get_down_load( &LHASH_OF($type) * &lh) {  &return  &OPENSSL_LH_get_down_load(( &OPENSSL_LHASH *) &lh); }  &static  &ossl_unused  &ossl_inline  &void  &lh_$type &_set_down_load( &LHASH_OF($type) * &lh, \'unsigned long dl\') {  &OPENSSL_LH_set_down_load(( &OPENSSL_LHASH *) &lh,  &dl); }  &static  &ossl_unused  &ossl_inline  &void  &lh_$type &_doall( &LHASH_OF($type) * &lh,  &void (* &doall)($type *)) {  &OPENSSL_LH_doall(( &OPENSSL_LHASH *) &lh, ( &OPENSSL_LH_DOALL_FUNC) &doall); }  &LHASH_OF($type));
    }' unless defined(&DEFINE_LHASH_OF);
    eval 'sub IMPLEMENT_LHASH_DOALL_ARG_CONST {
        my($type, $argtype) = @_;
	    eval q( &int_implement_lhash_doall($type, $argtype,  &const $type));
    }' unless defined(&IMPLEMENT_LHASH_DOALL_ARG_CONST);
    eval 'sub IMPLEMENT_LHASH_DOALL_ARG {
        my($type, $argtype) = @_;
	    eval q( &int_implement_lhash_doall($type, $argtype, $type));
    }' unless defined(&IMPLEMENT_LHASH_DOALL_ARG);
    eval 'sub int_implement_lhash_doall {
        my($type, $argtype, $cbargtype) = @_;
	    eval q( &static  &ossl_unused  &ossl_inline  &void  &lh_$type &_doall_$argtype( &LHASH_OF($type) * &lh,  &void (* &fn)($cbargtype *, $argtype *), $argtype * &arg) {  &OPENSSL_LH_doall_arg(( &OPENSSL_LHASH *) &lh, ( &OPENSSL_LH_DOALL_FUNCARG) &fn, ( &void *) &arg); }  &LHASH_OF($type));
    }' unless defined(&int_implement_lhash_doall);
    if(defined(&_MSC_VER)) {
    }
    if(defined(&_MSC_VER)) {
    }
    if(defined(&__SUNPRO_C)) {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
