require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&HEADER_PKCS7_H)) {
    eval 'sub HEADER_PKCS7_H () {1;}' unless defined(&HEADER_PKCS7_H);
    require 'openssl/asn1.ph';
    require 'openssl/bio.ph';
    require 'openssl/e_os2.ph';
    require 'openssl/symhacks.ph';
    require 'openssl/ossl_typ.ph';
    require 'openssl/pkcs7err.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub PKCS7_S_HEADER () {0;}' unless defined(&PKCS7_S_HEADER);
    eval 'sub PKCS7_S_BODY () {1;}' unless defined(&PKCS7_S_BODY);
    eval 'sub PKCS7_S_TAIL () {2;}' unless defined(&PKCS7_S_TAIL);
    eval 'sub PKCS7_OP_SET_DETACHED_SIGNATURE () {1;}' unless defined(&PKCS7_OP_SET_DETACHED_SIGNATURE);
    eval 'sub PKCS7_OP_GET_DETACHED_SIGNATURE () {2;}' unless defined(&PKCS7_OP_GET_DETACHED_SIGNATURE);
    eval 'sub PKCS7_get_signed_attributes {
        my($si) = @_;
	    eval q((($si)-> &auth_attr));
    }' unless defined(&PKCS7_get_signed_attributes);
    eval 'sub PKCS7_get_attributes {
        my($si) = @_;
	    eval q((($si)-> &unauth_attr));
    }' unless defined(&PKCS7_get_attributes);
    eval 'sub PKCS7_type_is_signed {
        my($a) = @_;
	    eval q(( &OBJ_obj2nid(($a)-> &type) ==  &NID_pkcs7_signed));
    }' unless defined(&PKCS7_type_is_signed);
    eval 'sub PKCS7_type_is_encrypted {
        my($a) = @_;
	    eval q(( &OBJ_obj2nid(($a)-> &type) ==  &NID_pkcs7_encrypted));
    }' unless defined(&PKCS7_type_is_encrypted);
    eval 'sub PKCS7_type_is_enveloped {
        my($a) = @_;
	    eval q(( &OBJ_obj2nid(($a)-> &type) ==  &NID_pkcs7_enveloped));
    }' unless defined(&PKCS7_type_is_enveloped);
    eval 'sub PKCS7_type_is_signedAndEnveloped {
        my($a) = @_;
	    eval q(( &OBJ_obj2nid(($a)-> &type) ==  &NID_pkcs7_signedAndEnveloped));
    }' unless defined(&PKCS7_type_is_signedAndEnveloped);
    eval 'sub PKCS7_type_is_data {
        my($a) = @_;
	    eval q(( &OBJ_obj2nid(($a)-> &type) ==  &NID_pkcs7_data));
    }' unless defined(&PKCS7_type_is_data);
    eval 'sub PKCS7_type_is_digest {
        my($a) = @_;
	    eval q(( &OBJ_obj2nid(($a)-> &type) ==  &NID_pkcs7_digest));
    }' unless defined(&PKCS7_type_is_digest);
    eval 'sub PKCS7_set_detached {
        my($p,$v) = @_;
	    eval q( &PKCS7_ctrl($p, &PKCS7_OP_SET_DETACHED_SIGNATURE,$v, &NULL));
    }' unless defined(&PKCS7_set_detached);
    eval 'sub PKCS7_get_detached {
        my($p) = @_;
	    eval q( &PKCS7_ctrl($p, &PKCS7_OP_GET_DETACHED_SIGNATURE,0, &NULL));
    }' unless defined(&PKCS7_get_detached);
    eval 'sub PKCS7_is_detached {
        my($p7) = @_;
	    eval q(( &PKCS7_type_is_signed($p7)  &&  &PKCS7_get_detached($p7)));
    }' unless defined(&PKCS7_is_detached);
    eval 'sub PKCS7_TEXT () {0x1;}' unless defined(&PKCS7_TEXT);
    eval 'sub PKCS7_NOCERTS () {0x2;}' unless defined(&PKCS7_NOCERTS);
    eval 'sub PKCS7_NOSIGS () {0x4;}' unless defined(&PKCS7_NOSIGS);
    eval 'sub PKCS7_NOCHAIN () {0x8;}' unless defined(&PKCS7_NOCHAIN);
    eval 'sub PKCS7_NOINTERN () {0x10;}' unless defined(&PKCS7_NOINTERN);
    eval 'sub PKCS7_NOVERIFY () {0x20;}' unless defined(&PKCS7_NOVERIFY);
    eval 'sub PKCS7_DETACHED () {0x40;}' unless defined(&PKCS7_DETACHED);
    eval 'sub PKCS7_BINARY () {0x80;}' unless defined(&PKCS7_BINARY);
    eval 'sub PKCS7_NOATTR () {0x100;}' unless defined(&PKCS7_NOATTR);
    eval 'sub PKCS7_NOSMIMECAP () {0x200;}' unless defined(&PKCS7_NOSMIMECAP);
    eval 'sub PKCS7_NOOLDMIMETYPE () {0x400;}' unless defined(&PKCS7_NOOLDMIMETYPE);
    eval 'sub PKCS7_CRLFEOL () {0x800;}' unless defined(&PKCS7_CRLFEOL);
    eval 'sub PKCS7_STREAM () {0x1000;}' unless defined(&PKCS7_STREAM);
    eval 'sub PKCS7_NOCRL () {0x2000;}' unless defined(&PKCS7_NOCRL);
    eval 'sub PKCS7_PARTIAL () {0x4000;}' unless defined(&PKCS7_PARTIAL);
    eval 'sub PKCS7_REUSE_DIGEST () {0x8000;}' unless defined(&PKCS7_REUSE_DIGEST);
    eval 'sub PKCS7_NO_DUAL_CONTENT () {0x10000;}' unless defined(&PKCS7_NO_DUAL_CONTENT);
    eval 'sub SMIME_TEXT () { &PKCS7_TEXT;}' unless defined(&SMIME_TEXT);
    eval 'sub SMIME_NOCERTS () { &PKCS7_NOCERTS;}' unless defined(&SMIME_NOCERTS);
    eval 'sub SMIME_NOSIGS () { &PKCS7_NOSIGS;}' unless defined(&SMIME_NOSIGS);
    eval 'sub SMIME_NOCHAIN () { &PKCS7_NOCHAIN;}' unless defined(&SMIME_NOCHAIN);
    eval 'sub SMIME_NOINTERN () { &PKCS7_NOINTERN;}' unless defined(&SMIME_NOINTERN);
    eval 'sub SMIME_NOVERIFY () { &PKCS7_NOVERIFY;}' unless defined(&SMIME_NOVERIFY);
    eval 'sub SMIME_DETACHED () { &PKCS7_DETACHED;}' unless defined(&SMIME_DETACHED);
    eval 'sub SMIME_BINARY () { &PKCS7_BINARY;}' unless defined(&SMIME_BINARY);
    eval 'sub SMIME_NOATTR () { &PKCS7_NOATTR;}' unless defined(&SMIME_NOATTR);
    eval 'sub SMIME_ASCIICRLF () {0x80000;}' unless defined(&SMIME_ASCIICRLF);
    unless(defined(&OPENSSL_NO_STDIO)) {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
