require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_HAVE_SYS_VIDEOIO_H)) {
    eval 'sub _HAVE_SYS_VIDEOIO_H () {1;}' unless defined(&_HAVE_SYS_VIDEOIO_H);
    require 'sys/types.ph';
    require 'sys/ioccom.ph';
    require 'sys/time.ph';
    if(defined(&_KERNEL)) {
	require 'compat/sys/time.ph';
    }
    unless(defined(&_KERNEL)) {
	unless(defined(&__linux_sized_types__)) {
	    eval 'sub __linux_sized_types__ () {1;}' unless defined(&__linux_sized_types__);
	    eval 'sub __u64 () { &uint64_t;}' unless defined(&__u64);
	    eval 'sub __u32 () { &uint32_t;}' unless defined(&__u32);
	    eval 'sub __u16 () { &uint16_t;}' unless defined(&__u16);
	    eval 'sub __u8 () { &uint8_t;}' unless defined(&__u8);
	    eval 'sub __s64 () { &int64_t;}' unless defined(&__s64);
	    eval 'sub __s32 () { &int32_t;}' unless defined(&__s32);
	    eval 'sub __s16 () { &int16_t;}' unless defined(&__s16);
	    eval 'sub __s8 () { &int8_t;}' unless defined(&__s8);
	}
    }
    eval 'sub v4l2_fourcc {
        my($a,$b,$c,$d) = @_;
	    eval q(((( &uint32_t)($a) << 0) | (( &uint32_t)($b) << 8) | (( &uint32_t)($c) << 16) | (( &uint32_t)($d) << 24)));
    }' unless defined(&v4l2_fourcc);
    if(0) {
	eval 'sub KERNEL_VERSION {
	    my($a,$b,$c) = @_;
    	    eval q(((($a) << 16) + (($b) << 8) + ($c)));
	}' unless defined(&KERNEL_VERSION);
    }
    eval 'sub V4L2_CTRL_ID2CLASS {
        my($id) = @_;
	    eval q((($id >> 16) & 0xfff));
    }' unless defined(&V4L2_CTRL_ID2CLASS);
    eval 'sub V4L2_CTRL_ID2CID {
        my($id) = @_;
	    eval q(($id & 0xffff));
    }' unless defined(&V4L2_CTRL_ID2CID);
    eval("sub V4L2_COLORSPACE_SMPTE170M () { 1; }") unless defined(&V4L2_COLORSPACE_SMPTE170M);
    eval("sub V4L2_COLORSPACE_SMPTE240M () { 2; }") unless defined(&V4L2_COLORSPACE_SMPTE240M);
    eval("sub V4L2_COLORSPACE_REC709 () { 3; }") unless defined(&V4L2_COLORSPACE_REC709);
    eval("sub V4L2_COLORSPACE_BT878 () { 4; }") unless defined(&V4L2_COLORSPACE_BT878);
    eval("sub V4L2_COLORSPACE_470_SYSTEM_M () { 5; }") unless defined(&V4L2_COLORSPACE_470_SYSTEM_M);
    eval("sub V4L2_COLORSPACE_470_SYSTEM_BG () { 6; }") unless defined(&V4L2_COLORSPACE_470_SYSTEM_BG);
    eval("sub V4L2_COLORSPACE_JPEG () { 7; }") unless defined(&V4L2_COLORSPACE_JPEG);
    eval("sub V4L2_COLORSPACE_SRGB () { 8; }") unless defined(&V4L2_COLORSPACE_SRGB);
    eval("sub V4L2_FIELD_ANY () { 0; }") unless defined(&V4L2_FIELD_ANY);
    eval("sub V4L2_FIELD_NONE () { 1; }") unless defined(&V4L2_FIELD_NONE);
    eval("sub V4L2_FIELD_TOP () { 2; }") unless defined(&V4L2_FIELD_TOP);
    eval("sub V4L2_FIELD_BOTTOM () { 3; }") unless defined(&V4L2_FIELD_BOTTOM);
    eval("sub V4L2_FIELD_INTERLACED () { 4; }") unless defined(&V4L2_FIELD_INTERLACED);
    eval("sub V4L2_FIELD_SEQ_TB () { 5; }") unless defined(&V4L2_FIELD_SEQ_TB);
    eval("sub V4L2_FIELD_SEQ_BT () { 6; }") unless defined(&V4L2_FIELD_SEQ_BT);
    eval("sub V4L2_FIELD_ALTERNATE () { 7; }") unless defined(&V4L2_FIELD_ALTERNATE);
    eval("sub V4L2_BUF_TYPE_VIDEO_CAPTURE () { 1; }") unless defined(&V4L2_BUF_TYPE_VIDEO_CAPTURE);
    eval("sub V4L2_BUF_TYPE_VIDEO_OUTPUT () { 2; }") unless defined(&V4L2_BUF_TYPE_VIDEO_OUTPUT);
    eval("sub V4L2_BUF_TYPE_VIDEO_OVERLAY () { 3; }") unless defined(&V4L2_BUF_TYPE_VIDEO_OVERLAY);
    eval("sub V4L2_BUF_TYPE_VBI_CAPTURE () { 4; }") unless defined(&V4L2_BUF_TYPE_VBI_CAPTURE);
    eval("sub V4L2_BUF_TYPE_VBI_OUTPUT () { 5; }") unless defined(&V4L2_BUF_TYPE_VBI_OUTPUT);
    eval("sub V4L2_BUF_TYPE_PRIVATE () { 0x80; }") unless defined(&V4L2_BUF_TYPE_PRIVATE);
    eval("sub V4L2_MEMORY_MMAP () { 1; }") unless defined(&V4L2_MEMORY_MMAP);
    eval("sub V4L2_MEMORY_USERPTR () { 2; }") unless defined(&V4L2_MEMORY_USERPTR);
    eval("sub V4L2_MEMORY_OVERLAY () { 3; }") unless defined(&V4L2_MEMORY_OVERLAY);
    eval("sub V4L2_PRIORITY_UNSET () { 0; }") unless defined(&V4L2_PRIORITY_UNSET);
    eval("sub V4L2_PRIORITY_BACKGROUND () { 1; }") unless defined(&V4L2_PRIORITY_BACKGROUND);
    eval("sub V4L2_PRIORITY_INTERACTIVE () { 2; }") unless defined(&V4L2_PRIORITY_INTERACTIVE);
    eval("sub V4L2_PRIORITY_RECORD () { 3; }") unless defined(&V4L2_PRIORITY_RECORD);
    eval("sub V4L2_PRIORITY_DEFAULT () { V4L2_PRIORITY_INTERACTIVE; }") unless defined(&V4L2_PRIORITY_DEFAULT);
    eval("sub V4L2_TUNER_RADIO () { 1; }") unless defined(&V4L2_TUNER_RADIO);
    eval("sub V4L2_TUNER_ANALOG_TV () { 2; }") unless defined(&V4L2_TUNER_ANALOG_TV);
    eval("sub V4L2_CTRL_TYPE_INTEGER () { 1; }") unless defined(&V4L2_CTRL_TYPE_INTEGER);
    eval("sub V4L2_CTRL_TYPE_BOOLEAN () { 2; }") unless defined(&V4L2_CTRL_TYPE_BOOLEAN);
    eval("sub V4L2_CTRL_TYPE_MENU () { 3; }") unless defined(&V4L2_CTRL_TYPE_MENU);
    eval("sub V4L2_CTRL_TYPE_BUTTON () { 4; }") unless defined(&V4L2_CTRL_TYPE_BUTTON);
    eval("sub V4L2_FRMSIZE_TYPE_DISCRETE () { 1; }") unless defined(&V4L2_FRMSIZE_TYPE_DISCRETE);
    eval("sub V4L2_FRMSIZE_TYPE_CONTINUOUS () { 2; }") unless defined(&V4L2_FRMSIZE_TYPE_CONTINUOUS);
    eval("sub V4L2_FRMSIZE_TYPE_STEPWISE () { 3; }") unless defined(&V4L2_FRMSIZE_TYPE_STEPWISE);
    if(defined(&_KERNEL)) {
    }
    eval 'sub V4L2_TC_TYPE_24FPS () {1;}' unless defined(&V4L2_TC_TYPE_24FPS);
    eval 'sub V4L2_TC_TYPE_25FPS () {2;}' unless defined(&V4L2_TC_TYPE_25FPS);
    eval 'sub V4L2_TC_TYPE_30FPS () {3;}' unless defined(&V4L2_TC_TYPE_30FPS);
    eval 'sub V4L2_TC_TYPE_50FPS () {4;}' unless defined(&V4L2_TC_TYPE_50FPS);
    eval 'sub V4L2_TC_TYPE_60FPS () {5;}' unless defined(&V4L2_TC_TYPE_60FPS);
    eval 'sub V4L2_TC_FLAG_DROPFRAME () {0x1;}' unless defined(&V4L2_TC_FLAG_DROPFRAME);
    eval 'sub V4L2_TC_FLAG_COLORFRAME () {0x2;}' unless defined(&V4L2_TC_FLAG_COLORFRAME);
    eval 'sub V4L2_TC_USERBITS_field () {0xc;}' unless defined(&V4L2_TC_USERBITS_field);
    eval 'sub V4L2_TC_USERBITS_USERDEFINED () {0x;}' unless defined(&V4L2_TC_USERBITS_USERDEFINED);
    eval 'sub V4L2_TC_USERBITS_8BITCHARS () {0x8;}' unless defined(&V4L2_TC_USERBITS_8BITCHARS);
    eval 'sub V4L2_BUF_FLAG_MAPPED () {0x1;}' unless defined(&V4L2_BUF_FLAG_MAPPED);
    eval 'sub V4L2_BUF_FLAG_QUEUED () {0x2;}' unless defined(&V4L2_BUF_FLAG_QUEUED);
    eval 'sub V4L2_BUF_FLAG_DONE () {0x4;}' unless defined(&V4L2_BUF_FLAG_DONE);
    eval 'sub V4L2_BUF_FLAG_KEYFRAME () {0x8;}' unless defined(&V4L2_BUF_FLAG_KEYFRAME);
    eval 'sub V4L2_BUF_FLAG_PFRAME () {0x10;}' unless defined(&V4L2_BUF_FLAG_PFRAME);
    eval 'sub V4L2_BUF_FLAG_BFRAME () {0x20;}' unless defined(&V4L2_BUF_FLAG_BFRAME);
    eval 'sub V4L2_BUF_FLAG_TIMECODE () {0x100;}' unless defined(&V4L2_BUF_FLAG_TIMECODE);
    eval 'sub V4L2_BUF_FLAG_INPUT () {0x200;}' unless defined(&V4L2_BUF_FLAG_INPUT);
    eval 'sub V4L2_FMT_FLAG_COMPRESSED () {0x1;}' unless defined(&V4L2_FMT_FLAG_COMPRESSED);
    eval 'sub V4L2_INPUT_TYPE_TUNER () {1;}' unless defined(&V4L2_INPUT_TYPE_TUNER);
    eval 'sub V4L2_INPUT_TYPE_CAMERA () {2;}' unless defined(&V4L2_INPUT_TYPE_CAMERA);
    eval 'sub V4L2_IN_ST_NO_POWER () {0x1;}' unless defined(&V4L2_IN_ST_NO_POWER);
    eval 'sub V4L2_IN_ST_NO_SIGNAL () {0x2;}' unless defined(&V4L2_IN_ST_NO_SIGNAL);
    eval 'sub V4L2_IN_ST_NO_COLOR () {0x4;}' unless defined(&V4L2_IN_ST_NO_COLOR);
    eval 'sub V4L2_IN_ST_NO_H_LOCK () {0x100;}' unless defined(&V4L2_IN_ST_NO_H_LOCK);
    eval 'sub V4L2_IN_ST_COLOR_KILL () {0x200;}' unless defined(&V4L2_IN_ST_COLOR_KILL);
    eval 'sub V4L2_IN_ST_NO_SYNC () {0x10000;}' unless defined(&V4L2_IN_ST_NO_SYNC);
    eval 'sub V4L2_IN_ST_NO_EQU () {0x20000;}' unless defined(&V4L2_IN_ST_NO_EQU);
    eval 'sub V4L2_IN_ST_NO_CARRIER () {0x40000;}' unless defined(&V4L2_IN_ST_NO_CARRIER);
    eval 'sub V4L2_IN_ST_MACROVISION () {0x1000000;}' unless defined(&V4L2_IN_ST_MACROVISION);
    eval 'sub V4L2_IN_ST_NO_ACCESS () {0x2000000;}' unless defined(&V4L2_IN_ST_NO_ACCESS);
    eval 'sub V4L2_IN_ST_VTR () {0x4000000;}' unless defined(&V4L2_IN_ST_VTR);
    eval 'sub V4L2_OUTPUT_TYPE_MODULATOR () {1;}' unless defined(&V4L2_OUTPUT_TYPE_MODULATOR);
    eval 'sub V4L2_OUTPUT_TYPE_ANALOG () {2;}' unless defined(&V4L2_OUTPUT_TYPE_ANALOG);
    eval 'sub V4L2_OUTPUT_TYPE_ANALOGVGAOVERLAY () {3;}' unless defined(&V4L2_OUTPUT_TYPE_ANALOGVGAOVERLAY);
    eval 'sub V4L2_AUDCAP_STEREO () {0x1;}' unless defined(&V4L2_AUDCAP_STEREO);
    eval 'sub V4L2_AUDCAP_AVL () {0x2;}' unless defined(&V4L2_AUDCAP_AVL);
    eval 'sub V4L2_AUDMODE_AVL () {0x1;}' unless defined(&V4L2_AUDMODE_AVL);
    eval 'sub V4L2_FBUF_CAP_EXTERNOVERLAY () {0x1;}' unless defined(&V4L2_FBUF_CAP_EXTERNOVERLAY);
    eval 'sub V4L2_FBUF_CAP_CHROMAKEY () {0x2;}' unless defined(&V4L2_FBUF_CAP_CHROMAKEY);
    eval 'sub V4L2_FBUF_CAP_LIST_CLIPPING () {0x4;}' unless defined(&V4L2_FBUF_CAP_LIST_CLIPPING);
    eval 'sub V4L2_FBUF_CAP_BITMAP_CLIPPING () {0x8;}' unless defined(&V4L2_FBUF_CAP_BITMAP_CLIPPING);
    eval 'sub V4L2_FBUF_FLAG_PRIMARY () {0x1;}' unless defined(&V4L2_FBUF_FLAG_PRIMARY);
    eval 'sub V4L2_FBUF_FLAG_OVERLAY () {0x2;}' unless defined(&V4L2_FBUF_FLAG_OVERLAY);
    eval 'sub V4L2_FBUF_FLAG_CHROMAKEY () {0x4;}' unless defined(&V4L2_FBUF_FLAG_CHROMAKEY);
    eval 'sub V4L2_JPEG_MARKER_DHT () {(1<< 3);}' unless defined(&V4L2_JPEG_MARKER_DHT);
    eval 'sub V4L2_JPEG_MARKER_DQT () {(1<< 4);}' unless defined(&V4L2_JPEG_MARKER_DQT);
    eval 'sub V4L2_JPEG_MARKER_DRI () {(1<< 5);}' unless defined(&V4L2_JPEG_MARKER_DRI);
    eval 'sub V4L2_JPEG_MARKER_COM () {(1<< 6);}' unless defined(&V4L2_JPEG_MARKER_COM);
    eval 'sub V4L2_JPEG_MARKER_APP () {(1<< 7);}' unless defined(&V4L2_JPEG_MARKER_APP);
    eval 'sub V4L2_CAP_TIMEPERFRAME () {0x1000;}' unless defined(&V4L2_CAP_TIMEPERFRAME);
    eval 'sub V4L2_MODE_HIGHQUALITY () {0x1;}' unless defined(&V4L2_MODE_HIGHQUALITY);
    eval 'sub V4L2_TUNER_CAP_LOW () {0x1;}' unless defined(&V4L2_TUNER_CAP_LOW);
    eval 'sub V4L2_TUNER_CAP_NORM () {0x2;}' unless defined(&V4L2_TUNER_CAP_NORM);
    eval 'sub V4L2_TUNER_CAP_STEREO () {0x10;}' unless defined(&V4L2_TUNER_CAP_STEREO);
    eval 'sub V4L2_TUNER_CAP_LANG2 () {0x20;}' unless defined(&V4L2_TUNER_CAP_LANG2);
    eval 'sub V4L2_TUNER_CAP_SAP () {0x20;}' unless defined(&V4L2_TUNER_CAP_SAP);
    eval 'sub V4L2_TUNER_CAP_LANG1 () {0x40;}' unless defined(&V4L2_TUNER_CAP_LANG1);
    eval 'sub V4L2_TUNER_SUB_MONO () {0x1;}' unless defined(&V4L2_TUNER_SUB_MONO);
    eval 'sub V4L2_TUNER_SUB_STEREO () {0x2;}' unless defined(&V4L2_TUNER_SUB_STEREO);
    eval 'sub V4L2_TUNER_SUB_LANG2 () {0x4;}' unless defined(&V4L2_TUNER_SUB_LANG2);
    eval 'sub V4L2_TUNER_SUB_SAP () {0x4;}' unless defined(&V4L2_TUNER_SUB_SAP);
    eval 'sub V4L2_TUNER_SUB_LANG1 () {0x8;}' unless defined(&V4L2_TUNER_SUB_LANG1);
    eval 'sub V4L2_TUNER_MODE_MONO () {0;}' unless defined(&V4L2_TUNER_MODE_MONO);
    eval 'sub V4L2_TUNER_MODE_STEREO () {1;}' unless defined(&V4L2_TUNER_MODE_STEREO);
    eval 'sub V4L2_TUNER_MODE_LANG2 () {2;}' unless defined(&V4L2_TUNER_MODE_LANG2);
    eval 'sub V4L2_TUNER_MODE_SAP () {2;}' unless defined(&V4L2_TUNER_MODE_SAP);
    eval 'sub V4L2_TUNER_MODE_LANG1 () {3;}' unless defined(&V4L2_TUNER_MODE_LANG1);
    eval 'sub V4L2_TUNER_MODE_LANG1_LANG2 () {4;}' unless defined(&V4L2_TUNER_MODE_LANG1_LANG2);
    eval 'sub V4L2_CTRL_FLAG_DISABLED () {0x1;}' unless defined(&V4L2_CTRL_FLAG_DISABLED);
    eval 'sub V4L2_CTRL_FLAG_GRABBED () {0x2;}' unless defined(&V4L2_CTRL_FLAG_GRABBED);
    eval 'sub V4L2_CTRL_FLAG_READ_ONLY () {0x4;}' unless defined(&V4L2_CTRL_FLAG_READ_ONLY);
    eval 'sub V4L2_CTRL_FLAG_UPDATE () {0x8;}' unless defined(&V4L2_CTRL_FLAG_UPDATE);
    eval 'sub V4L2_CTRL_FLAG_INACTIVE () {0x10;}' unless defined(&V4L2_CTRL_FLAG_INACTIVE);
    eval 'sub V4L2_CTRL_FLAG_SLIDER () {0x20;}' unless defined(&V4L2_CTRL_FLAG_SLIDER);
    eval 'sub V4L2_CID_BASE () {0x980900;}' unless defined(&V4L2_CID_BASE);
    eval 'sub V4L2_CID_PRIVATE_BASE () {0x8000000;}' unless defined(&V4L2_CID_PRIVATE_BASE);
    eval 'sub V4L2_CID_BRIGHTNESS () {( &V4L2_CID_BASE + 0);}' unless defined(&V4L2_CID_BRIGHTNESS);
    eval 'sub V4L2_CID_CONTRAST () {( &V4L2_CID_BASE + 1);}' unless defined(&V4L2_CID_CONTRAST);
    eval 'sub V4L2_CID_SATURATION () {( &V4L2_CID_BASE + 2);}' unless defined(&V4L2_CID_SATURATION);
    eval 'sub V4L2_CID_HUE () {( &V4L2_CID_BASE + 3);}' unless defined(&V4L2_CID_HUE);
    eval 'sub V4L2_CID_AUDIO_VOLUME () {( &V4L2_CID_BASE + 5);}' unless defined(&V4L2_CID_AUDIO_VOLUME);
    eval 'sub V4L2_CID_AUDIO_BALANCE () {( &V4L2_CID_BASE + 6);}' unless defined(&V4L2_CID_AUDIO_BALANCE);
    eval 'sub V4L2_CID_AUDIO_BASS () {( &V4L2_CID_BASE + 7);}' unless defined(&V4L2_CID_AUDIO_BASS);
    eval 'sub V4L2_CID_AUDIO_TREBLE () {( &V4L2_CID_BASE + 8);}' unless defined(&V4L2_CID_AUDIO_TREBLE);
    eval 'sub V4L2_CID_AUDIO_MUTE () {( &V4L2_CID_BASE + 9);}' unless defined(&V4L2_CID_AUDIO_MUTE);
    eval 'sub V4L2_CID_AUDIO_LOUDNESS () {( &V4L2_CID_BASE + 10);}' unless defined(&V4L2_CID_AUDIO_LOUDNESS);
    eval 'sub V4L2_CID_BLACK_LEVEL () {( &V4L2_CID_BASE + 11);}' unless defined(&V4L2_CID_BLACK_LEVEL);
    eval 'sub V4L2_CID_AUTO_WHITE_BALANCE () {( &V4L2_CID_BASE + 12);}' unless defined(&V4L2_CID_AUTO_WHITE_BALANCE);
    eval 'sub V4L2_CID_DO_WHITE_BALANCE () {( &V4L2_CID_BASE + 13);}' unless defined(&V4L2_CID_DO_WHITE_BALANCE);
    eval 'sub V4L2_CID_RED_BALANCE () {( &V4L2_CID_BASE + 14);}' unless defined(&V4L2_CID_RED_BALANCE);
    eval 'sub V4L2_CID_BLUE_BALANCE () {( &V4L2_CID_BASE + 15);}' unless defined(&V4L2_CID_BLUE_BALANCE);
    eval 'sub V4L2_CID_GAMMA () {( &V4L2_CID_BASE + 16);}' unless defined(&V4L2_CID_GAMMA);
    eval 'sub V4L2_CID_WHITENESS () {( &V4L2_CID_GAMMA);}' unless defined(&V4L2_CID_WHITENESS);
    eval 'sub V4L2_CID_EXPOSURE () {( &V4L2_CID_BASE + 17);}' unless defined(&V4L2_CID_EXPOSURE);
    eval 'sub V4L2_CID_AUTOGAIN () {( &V4L2_CID_BASE + 18);}' unless defined(&V4L2_CID_AUTOGAIN);
    eval 'sub V4L2_CID_GAIN () {( &V4L2_CID_BASE + 19);}' unless defined(&V4L2_CID_GAIN);
    eval 'sub V4L2_CID_HFLIP () {( &V4L2_CID_BASE + 20);}' unless defined(&V4L2_CID_HFLIP);
    eval 'sub V4L2_CID_VFLIP () {( &V4L2_CID_BASE + 21);}' unless defined(&V4L2_CID_VFLIP);
    eval 'sub V4L2_CID_HCENTER_DEPRECATED () {( &V4L2_CID_BASE + 22);}' unless defined(&V4L2_CID_HCENTER_DEPRECATED);
    eval 'sub V4L2_CID_VCENTER_DEPRECATED () {( &V4L2_CID_BASE + 23);}' unless defined(&V4L2_CID_VCENTER_DEPRECATED);
    eval 'sub V4L2_CID_HCENTER () { &V4L2_CID_HCENTER_DEPRECATED;}' unless defined(&V4L2_CID_HCENTER);
    eval 'sub V4L2_CID_VCENTER () { &V4L2_CID_VCENTER_DEPRECATED;}' unless defined(&V4L2_CID_VCENTER);
    eval 'sub V4L2_CID_POWER_LINE_FREQUENCY () {( &V4L2_CID_BASE + 24);}' unless defined(&V4L2_CID_POWER_LINE_FREQUENCY);
    eval 'sub V4L2_CID_HUE_AUTO () {( &V4L2_CID_BASE + 25);}' unless defined(&V4L2_CID_HUE_AUTO);
    eval 'sub V4L2_CID_WHITE_BALANCE_TEMPERATURE () {( &V4L2_CID_BASE + 26);}' unless defined(&V4L2_CID_WHITE_BALANCE_TEMPERATURE);
    eval 'sub V4L2_CID_SHARPNESS () {( &V4L2_CID_BASE + 27);}' unless defined(&V4L2_CID_SHARPNESS);
    eval 'sub V4L2_CID_BACKLIGHT_COMPENSATION () {( &V4L2_CID_BASE + 28);}' unless defined(&V4L2_CID_BACKLIGHT_COMPENSATION);
    eval 'sub V4L2_CID_LASTP1 () {( &V4L2_CID_BASE + 29);}' unless defined(&V4L2_CID_LASTP1);
    eval 'sub V4L2_PIX_FMT_RGB332 () { &v4l2_fourcc(ord(\'R\', \'G\', \'B\', \'1\'));}' unless defined(&V4L2_PIX_FMT_RGB332);
    eval 'sub V4L2_PIX_FMT_RGB555 () { &v4l2_fourcc(ord(\'R\', \'G\', \'B\', \'O\'));}' unless defined(&V4L2_PIX_FMT_RGB555);
    eval 'sub V4L2_PIX_FMT_RGB565 () { &v4l2_fourcc(ord(\'R\', \'G\', \'B\', \'P\'));}' unless defined(&V4L2_PIX_FMT_RGB565);
    eval 'sub V4L2_PIX_FMT_RGB555X () { &v4l2_fourcc(ord(\'R\', \'G\', \'B\', \'Q\'));}' unless defined(&V4L2_PIX_FMT_RGB555X);
    eval 'sub V4L2_PIX_FMT_RGB565X () { &v4l2_fourcc(ord(\'R\', \'G\', \'B\', \'R\'));}' unless defined(&V4L2_PIX_FMT_RGB565X);
    eval 'sub V4L2_PIX_FMT_BGR24 () { &v4l2_fourcc(ord(\'B\', \'G\', \'R\', \'3\'));}' unless defined(&V4L2_PIX_FMT_BGR24);
    eval 'sub V4L2_PIX_FMT_RGB24 () { &v4l2_fourcc(ord(\'R\', \'G\', \'B\', \'3\'));}' unless defined(&V4L2_PIX_FMT_RGB24);
    eval 'sub V4L2_PIX_FMT_BGR32 () { &v4l2_fourcc(ord(\'B\', \'G\', \'R\', \'4\'));}' unless defined(&V4L2_PIX_FMT_BGR32);
    eval 'sub V4L2_PIX_FMT_RGB32 () { &v4l2_fourcc(ord(\'R\', \'G\', \'B\', \'4\'));}' unless defined(&V4L2_PIX_FMT_RGB32);
    eval 'sub V4L2_PIX_FMT_GREY () { &v4l2_fourcc(ord(\'G\', \'R\', \'E\', \'Y\'));}' unless defined(&V4L2_PIX_FMT_GREY);
    eval 'sub V4L2_PIX_FMT_YUYV () { &v4l2_fourcc(ord(\'Y\', \'U\', \'Y\', \'V\'));}' unless defined(&V4L2_PIX_FMT_YUYV);
    eval 'sub V4L2_PIX_FMT_UYVY () { &v4l2_fourcc(ord(\'U\', \'Y\', \'V\', \'Y\'));}' unless defined(&V4L2_PIX_FMT_UYVY);
    eval 'sub V4L2_PIX_FMT_Y41P () { &v4l2_fourcc(ord(\'Y\', \'4\', \'1\', \'P\'));}' unless defined(&V4L2_PIX_FMT_Y41P);
    eval 'sub V4L2_PIX_FMT_YVU420 () { &v4l2_fourcc(ord(\'Y\', \'V\', \'1\', \'2\'));}' unless defined(&V4L2_PIX_FMT_YVU420);
    eval 'sub V4L2_PIX_FMT_YUV420 () { &v4l2_fourcc(ord(\'Y\', \'U\', \'1\', \'2\'));}' unless defined(&V4L2_PIX_FMT_YUV420);
    eval 'sub V4L2_PIX_FMT_YVU410 () { &v4l2_fourcc(ord(\'Y\', \'V\', \'U\', \'9\'));}' unless defined(&V4L2_PIX_FMT_YVU410);
    eval 'sub V4L2_PIX_FMT_YUV410 () { &v4l2_fourcc(ord(\'Y\', \'U\', \'V\', \'9\'));}' unless defined(&V4L2_PIX_FMT_YUV410);
    eval 'sub V4L2_PIX_FMT_YUV422P () { &v4l2_fourcc(ord(\'4\', \'2\', \'2\', \'P\'));}' unless defined(&V4L2_PIX_FMT_YUV422P);
    eval 'sub V4L2_PIX_FMT_YUV411P () { &v4l2_fourcc(ord(\'Y\', \'1\', \'1\', \'P\'));}' unless defined(&V4L2_PIX_FMT_YUV411P);
    eval 'sub V4L2_PIX_FMT_NV12 () { &v4l2_fourcc(ord(\'N\', \'V\', \'1\', \'2\'));}' unless defined(&V4L2_PIX_FMT_NV12);
    eval 'sub V4L2_PIX_FMT_NV21 () { &v4l2_fourcc(ord(\'N\', \'V\', \'2\', \'1\'));}' unless defined(&V4L2_PIX_FMT_NV21);
    eval 'sub V4L2_PIX_FMT_SBGGR8 () { &v4l2_fourcc(ord(\'B\', \'A\', \'8\', \'1\'));}' unless defined(&V4L2_PIX_FMT_SBGGR8);
    eval 'sub V4L2_PIX_FMT_YYUV () { &v4l2_fourcc(ord(\'Y\', \'Y\', \'U\', \'V\'));}' unless defined(&V4L2_PIX_FMT_YYUV);
    eval 'sub V4L2_PIX_FMT_HI240 () { &v4l2_fourcc(ord(\'H\', \'I\', \'2\', \'4\'));}' unless defined(&V4L2_PIX_FMT_HI240);
    eval 'sub V4L2_PIX_FMT_MJPEG () { &v4l2_fourcc(ord(\'M\', \'J\', \'P\', \'G\'));}' unless defined(&V4L2_PIX_FMT_MJPEG);
    eval 'sub V4L2_PIX_FMT_JPEG () { &v4l2_fourcc(ord(\'J\', \'P\', \'E\', \'G\'));}' unless defined(&V4L2_PIX_FMT_JPEG);
    eval 'sub V4L2_PIX_FMT_DV () { &v4l2_fourcc(ord(\'d\', \'v\', \'s\', \'d\'));}' unless defined(&V4L2_PIX_FMT_DV);
    eval 'sub V4L2_PIX_FMT_MPEG () { &v4l2_fourcc(ord(\'M\', \'P\', \'E\', \'G\'));}' unless defined(&V4L2_PIX_FMT_MPEG);
    eval 'sub V4L2_PIX_FMT_WNVA () { &v4l2_fourcc(ord(\'W\', \'N\', \'V\', \'A\'));}' unless defined(&V4L2_PIX_FMT_WNVA);
    eval 'sub V4L2_PIX_FMT_SN9C10X () { &v4l2_fourcc(ord(\'S\', \'9\', \'1\', \'0\'));}' unless defined(&V4L2_PIX_FMT_SN9C10X);
    eval 'sub V4L2_STD_PAL_B () {(( &v4l2_std_id)0x1);}' unless defined(&V4L2_STD_PAL_B);
    eval 'sub V4L2_STD_PAL_B1 () {(( &v4l2_std_id)0x2);}' unless defined(&V4L2_STD_PAL_B1);
    eval 'sub V4L2_STD_PAL_G () {(( &v4l2_std_id)0x4);}' unless defined(&V4L2_STD_PAL_G);
    eval 'sub V4L2_STD_PAL_H () {(( &v4l2_std_id)0x8);}' unless defined(&V4L2_STD_PAL_H);
    eval 'sub V4L2_STD_PAL_I () {(( &v4l2_std_id)0x10);}' unless defined(&V4L2_STD_PAL_I);
    eval 'sub V4L2_STD_PAL_D () {(( &v4l2_std_id)0x20);}' unless defined(&V4L2_STD_PAL_D);
    eval 'sub V4L2_STD_PAL_D1 () {(( &v4l2_std_id)0x40);}' unless defined(&V4L2_STD_PAL_D1);
    eval 'sub V4L2_STD_PAL_K () {(( &v4l2_std_id)0x80);}' unless defined(&V4L2_STD_PAL_K);
    eval 'sub V4L2_STD_PAL_M () {(( &v4l2_std_id)0x100);}' unless defined(&V4L2_STD_PAL_M);
    eval 'sub V4L2_STD_PAL_N () {(( &v4l2_std_id)0x200);}' unless defined(&V4L2_STD_PAL_N);
    eval 'sub V4L2_STD_PAL_Nc () {(( &v4l2_std_id)0x400);}' unless defined(&V4L2_STD_PAL_Nc);
    eval 'sub V4L2_STD_PAL_60 () {(( &v4l2_std_id)0x800);}' unless defined(&V4L2_STD_PAL_60);
    eval 'sub V4L2_STD_NTSC_M () {(( &v4l2_std_id)0x1000);}' unless defined(&V4L2_STD_NTSC_M);
    eval 'sub V4L2_STD_NTSC_M_JP () {(( &v4l2_std_id)0x2000);}' unless defined(&V4L2_STD_NTSC_M_JP);
    eval 'sub V4L2_STD_SECAM_B () {(( &v4l2_std_id)0x10000);}' unless defined(&V4L2_STD_SECAM_B);
    eval 'sub V4L2_STD_SECAM_D () {(( &v4l2_std_id)0x20000);}' unless defined(&V4L2_STD_SECAM_D);
    eval 'sub V4L2_STD_SECAM_G () {(( &v4l2_std_id)0x40000);}' unless defined(&V4L2_STD_SECAM_G);
    eval 'sub V4L2_STD_SECAM_H () {(( &v4l2_std_id)0x80000);}' unless defined(&V4L2_STD_SECAM_H);
    eval 'sub V4L2_STD_SECAM_K () {(( &v4l2_std_id)0x100000);}' unless defined(&V4L2_STD_SECAM_K);
    eval 'sub V4L2_STD_SECAM_K1 () {(( &v4l2_std_id)0x200000);}' unless defined(&V4L2_STD_SECAM_K1);
    eval 'sub V4L2_STD_SECAM_L () {(( &v4l2_std_id)0x400000);}' unless defined(&V4L2_STD_SECAM_L);
    eval 'sub V4L2_STD_ATSC_8_VSB () {(( &v4l2_std_id)0x1000000);}' unless defined(&V4L2_STD_ATSC_8_VSB);
    eval 'sub V4L2_STD_ATSC_16_VSB () {(( &v4l2_std_id)0x2000000);}' unless defined(&V4L2_STD_ATSC_16_VSB);
    eval 'sub V4L2_STD_PAL_BG () {( &V4L2_STD_PAL_B |  &V4L2_STD_PAL_B1 |  &V4L2_STD_PAL_G);}' unless defined(&V4L2_STD_PAL_BG);
    eval 'sub V4L2_STD_PAL_DK () {( &V4L2_STD_PAL_D |  &V4L2_STD_PAL_D1 |  &V4L2_STD_PAL_K);}' unless defined(&V4L2_STD_PAL_DK);
    eval 'sub V4L2_STD_PAL () {( &V4L2_STD_PAL_BG |  &V4L2_STD_PAL_DK |  &V4L2_STD_PAL_H |  &V4L2_STD_PAL_I);}' unless defined(&V4L2_STD_PAL);
    eval 'sub V4L2_STD_NTSC () {( &V4L2_STD_NTSC_M |  &V4L2_STD_NTSC_M_JP);}' unless defined(&V4L2_STD_NTSC);
    eval 'sub V4L2_STD_SECAM () {( &V4L2_STD_SECAM_B |  &V4L2_STD_SECAM_D |  &V4L2_STD_SECAM_G |  &V4L2_STD_SECAM_H |  &V4L2_STD_SECAM_K |  &V4L2_STD_SECAM_K1 |  &V4L2_STD_SECAM_L);}' unless defined(&V4L2_STD_SECAM);
    eval 'sub V4L2_STD_525_60 () {( &V4L2_STD_PAL_M |  &V4L2_STD_PAL_60 |  &V4L2_STD_NTSC);}' unless defined(&V4L2_STD_525_60);
    eval 'sub V4L2_STD_625_50 () {( &V4L2_STD_PAL |  &V4L2_STD_PAL_N |  &V4L2_STD_PAL_Nc |  &V4L2_STD_SECAM);}' unless defined(&V4L2_STD_625_50);
    eval 'sub V4L2_STD_UNKNOWN () {0;}' unless defined(&V4L2_STD_UNKNOWN);
    eval 'sub V4L2_STD_ALL () {( &V4L2_STD_525_60 |  &V4L2_STD_625_50);}' unless defined(&V4L2_STD_ALL);
    eval 'sub V4L2_VBI_UNSYNC () {0x1;}' unless defined(&V4L2_VBI_UNSYNC);
    eval 'sub V4L2_VBI_INTERLACED () {0x2;}' unless defined(&V4L2_VBI_INTERLACED);
    eval 'sub V4L2_CAP_VIDEO_CAPTURE () {0x1;}' unless defined(&V4L2_CAP_VIDEO_CAPTURE);
    eval 'sub V4L2_CAP_VIDEO_OUTPUT () {0x2;}' unless defined(&V4L2_CAP_VIDEO_OUTPUT);
    eval 'sub V4L2_CAP_VIDEO_OVERLAY () {0x4;}' unless defined(&V4L2_CAP_VIDEO_OVERLAY);
    eval 'sub V4L2_CAP_VBI_CAPTURE () {0x10;}' unless defined(&V4L2_CAP_VBI_CAPTURE);
    eval 'sub V4L2_CAP_VBI_OUTPUT () {0x20;}' unless defined(&V4L2_CAP_VBI_OUTPUT);
    eval 'sub V4L2_CAP_RDS_CAPTURE () {0x100;}' unless defined(&V4L2_CAP_RDS_CAPTURE);
    eval 'sub V4L2_CAP_TUNER () {0x10000;}' unless defined(&V4L2_CAP_TUNER);
    eval 'sub V4L2_CAP_AUDIO () {0x20000;}' unless defined(&V4L2_CAP_AUDIO);
    eval 'sub V4L2_CAP_READWRITE () {0x1000000;}' unless defined(&V4L2_CAP_READWRITE);
    eval 'sub V4L2_CAP_ASYNCIO () {0x2000000;}' unless defined(&V4L2_CAP_ASYNCIO);
    eval 'sub V4L2_CAP_STREAMING () {0x4000000;}' unless defined(&V4L2_CAP_STREAMING);
    eval 'sub V4L2_CAP_BITMASK () {"\\20\\1VIDEO_CAPTURE\\2VIDEO_OUTPUT\\3VIDEO_OVERLAY" "\\5VBI_CAPTURE\\6VBI_OUTPUT\\10RDS_CAPTURE" "\\21TUNER\\22AUDIO\\31READWRITE" "\\32ASYNCIO\\33STREAMING";}' unless defined(&V4L2_CAP_BITMASK);
    eval 'sub VIDIOC_QUERYCAP () { &_IOR(ord(\'V\'), 0, \'struct v4l2_capability\');}' unless defined(&VIDIOC_QUERYCAP);
    eval 'sub VIDIOC_RESERVED () { &_IO(ord(\'V\'), 1);}' unless defined(&VIDIOC_RESERVED);
    eval 'sub VIDIOC_ENUM_FMT () { &_IOWR(ord(\'V\'), 2, \'struct v4l2_fmtdesc\');}' unless defined(&VIDIOC_ENUM_FMT);
    eval 'sub VIDIOC_G_FMT () { &_IOWR(ord(\'V\'), 4, \'struct v4l2_format\');}' unless defined(&VIDIOC_G_FMT);
    eval 'sub VIDIOC_S_FMT () { &_IOWR(ord(\'V\'), 5, \'struct v4l2_format\');}' unless defined(&VIDIOC_S_FMT);
    eval 'sub VIDIOC_REQBUFS () { &_IOWR(ord(\'V\'), 8, \'struct v4l2_requestbuffers\');}' unless defined(&VIDIOC_REQBUFS);
    eval 'sub VIDIOC_QUERYBUF () { &_IOWR(ord(\'V\'), 9, \'struct v4l2_buffer\');}' unless defined(&VIDIOC_QUERYBUF);
    eval 'sub VIDIOC_G_FBUF () { &_IOR(ord(\'V\'), 10, \'struct v4l2_framebuffer\');}' unless defined(&VIDIOC_G_FBUF);
    eval 'sub VIDIOC_S_FBUF () { &_IOW(ord(\'V\'), 11, \'struct v4l2_framebuffer\');}' unless defined(&VIDIOC_S_FBUF);
    eval 'sub VIDIOC_OVERLAY () { &_IOW(ord(\'V\'), 14, \'int\');}' unless defined(&VIDIOC_OVERLAY);
    eval 'sub VIDIOC_QBUF () { &_IOWR(ord(\'V\'), 15, \'struct v4l2_buffer\');}' unless defined(&VIDIOC_QBUF);
    eval 'sub VIDIOC_DQBUF () { &_IOWR(ord(\'V\'), 17, \'struct v4l2_buffer\');}' unless defined(&VIDIOC_DQBUF);
    eval 'sub VIDIOC_STREAMON () { &_IOW(ord(\'V\'), 18, \'int\');}' unless defined(&VIDIOC_STREAMON);
    eval 'sub VIDIOC_STREAMOFF () { &_IOW(ord(\'V\'), 19, \'int\');}' unless defined(&VIDIOC_STREAMOFF);
    eval 'sub VIDIOC_G_PARM () { &_IOWR(ord(\'V\'), 21, \'struct v4l2_streamparm\');}' unless defined(&VIDIOC_G_PARM);
    eval 'sub VIDIOC_S_PARM () { &_IOWR(ord(\'V\'), 22, \'struct v4l2_streamparm\');}' unless defined(&VIDIOC_S_PARM);
    eval 'sub VIDIOC_G_STD () { &_IOR(ord(\'V\'), 23,  &v4l2_std_id);}' unless defined(&VIDIOC_G_STD);
    eval 'sub VIDIOC_S_STD () { &_IOW(ord(\'V\'), 24,  &v4l2_std_id);}' unless defined(&VIDIOC_S_STD);
    eval 'sub VIDIOC_ENUMSTD () { &_IOWR(ord(\'V\'), 25, \'struct v4l2_standard\');}' unless defined(&VIDIOC_ENUMSTD);
    eval 'sub VIDIOC_ENUMINPUT () { &_IOWR(ord(\'V\'), 26, \'struct v4l2_input\');}' unless defined(&VIDIOC_ENUMINPUT);
    eval 'sub VIDIOC_G_CTRL () { &_IOWR(ord(\'V\'), 27, \'struct v4l2_control\');}' unless defined(&VIDIOC_G_CTRL);
    eval 'sub VIDIOC_S_CTRL () { &_IOWR(ord(\'V\'), 28, \'struct v4l2_control\');}' unless defined(&VIDIOC_S_CTRL);
    eval 'sub VIDIOC_G_TUNER () { &_IOWR(ord(\'V\'), 29, \'struct v4l2_tuner\');}' unless defined(&VIDIOC_G_TUNER);
    eval 'sub VIDIOC_S_TUNER () { &_IOW(ord(\'V\'), 30, \'struct v4l2_tuner\');}' unless defined(&VIDIOC_S_TUNER);
    eval 'sub VIDIOC_G_AUDIO () { &_IOR(ord(\'V\'), 33, \'struct v4l2_audio\');}' unless defined(&VIDIOC_G_AUDIO);
    eval 'sub VIDIOC_S_AUDIO () { &_IOW(ord(\'V\'), 34, \'struct v4l2_audio\');}' unless defined(&VIDIOC_S_AUDIO);
    eval 'sub VIDIOC_QUERYCTRL () { &_IOWR(ord(\'V\'), 36, \'struct v4l2_queryctrl\');}' unless defined(&VIDIOC_QUERYCTRL);
    eval 'sub VIDIOC_QUERYMENU () { &_IOWR(ord(\'V\'), 37, \'struct v4l2_querymenu\');}' unless defined(&VIDIOC_QUERYMENU);
    eval 'sub VIDIOC_G_INPUT () { &_IOR(ord(\'V\'), 38, \'int\');}' unless defined(&VIDIOC_G_INPUT);
    eval 'sub VIDIOC_S_INPUT () { &_IOWR(ord(\'V\'), 39, \'int\');}' unless defined(&VIDIOC_S_INPUT);
    eval 'sub VIDIOC_G_OUTPUT () { &_IOR(ord(\'V\'), 46, \'int\');}' unless defined(&VIDIOC_G_OUTPUT);
    eval 'sub VIDIOC_S_OUTPUT () { &_IOWR(ord(\'V\'), 47, \'int\');}' unless defined(&VIDIOC_S_OUTPUT);
    eval 'sub VIDIOC_ENUMOUTPUT () { &_IOWR(ord(\'V\'), 48, \'struct v4l2_output\');}' unless defined(&VIDIOC_ENUMOUTPUT);
    eval 'sub VIDIOC_G_AUDOUT () { &_IOR(ord(\'V\'), 49, \'struct v4l2_audioout\');}' unless defined(&VIDIOC_G_AUDOUT);
    eval 'sub VIDIOC_S_AUDOUT () { &_IOW(ord(\'V\'), 50, \'struct v4l2_audioout\');}' unless defined(&VIDIOC_S_AUDOUT);
    eval 'sub VIDIOC_G_MODULATOR () { &_IOWR(ord(\'V\'), 54, \'struct v4l2_modulator\');}' unless defined(&VIDIOC_G_MODULATOR);
    eval 'sub VIDIOC_S_MODULATOR () { &_IOW(ord(\'V\'), 55, \'struct v4l2_modulator\');}' unless defined(&VIDIOC_S_MODULATOR);
    eval 'sub VIDIOC_G_FREQUENCY () { &_IOWR(ord(\'V\'), 56, \'struct v4l2_frequency\');}' unless defined(&VIDIOC_G_FREQUENCY);
    eval 'sub VIDIOC_S_FREQUENCY () { &_IOW(ord(\'V\'), 57, \'struct v4l2_frequency\');}' unless defined(&VIDIOC_S_FREQUENCY);
    eval 'sub VIDIOC_CROPCAP () { &_IOWR(ord(\'V\'), 58, \'struct v4l2_cropcap\');}' unless defined(&VIDIOC_CROPCAP);
    eval 'sub VIDIOC_G_CROP () { &_IOWR(ord(\'V\'), 59, \'struct v4l2_crop\');}' unless defined(&VIDIOC_G_CROP);
    eval 'sub VIDIOC_S_CROP () { &_IOW(ord(\'V\'), 60, \'struct v4l2_crop\');}' unless defined(&VIDIOC_S_CROP);
    eval 'sub VIDIOC_G_JPEGCOMP () { &_IOR(ord(\'V\'), 61, \'struct v4l2_jpegcompression\');}' unless defined(&VIDIOC_G_JPEGCOMP);
    eval 'sub VIDIOC_S_JPEGCOMP () { &_IOW(ord(\'V\'), 62, \'struct v4l2_jpegcompression\');}' unless defined(&VIDIOC_S_JPEGCOMP);
    eval 'sub VIDIOC_QUERYSTD () { &_IOR(ord(\'V\'), 63,  &v4l2_std_id);}' unless defined(&VIDIOC_QUERYSTD);
    eval 'sub VIDIOC_TRY_FMT () { &_IOWR(ord(\'V\'), 64, \'struct v4l2_format\');}' unless defined(&VIDIOC_TRY_FMT);
    eval 'sub VIDIOC_ENUMAUDIO () { &_IOWR(ord(\'V\'), 65, \'struct v4l2_audio\');}' unless defined(&VIDIOC_ENUMAUDIO);
    eval 'sub VIDIOC_ENUMAUDOUT () { &_IOWR(ord(\'V\'), 66, \'struct v4l2_audioout\');}' unless defined(&VIDIOC_ENUMAUDOUT);
    eval 'sub VIDIOC_G_PRIORITY () { &_IOR(ord(\'V\'), 67,  &enum  &v4l2_priority);}' unless defined(&VIDIOC_G_PRIORITY);
    eval 'sub VIDIOC_S_PRIORITY () { &_IOW(ord(\'V\'), 68,  &enum  &v4l2_priority);}' unless defined(&VIDIOC_S_PRIORITY);
    eval 'sub VIDIOC_ENUM_FRAMESIZES () { &_IOWR(ord(\'V\'), 74, \'struct v4l2_frmsizeenum\');}' unless defined(&VIDIOC_ENUM_FRAMESIZES);
    eval 'sub VIDIOC_ENUM_FRAMEINTERVALS () { &_IOWR(ord(\'V\'), 75, \'struct v4l2_frmivalenum\');}' unless defined(&VIDIOC_ENUM_FRAMEINTERVALS);
    if(defined(&_KERNEL)) {
	eval 'sub VIDIOC_QUERYBUF50 () { &_IOWR(ord(\'V\'), 9, \'struct v4l2_buffer50\');}' unless defined(&VIDIOC_QUERYBUF50);
	eval 'sub VIDIOC_QBUF50 () { &_IOWR(ord(\'V\'), 15, \'struct v4l2_buffer50\');}' unless defined(&VIDIOC_QBUF50);
	eval 'sub VIDIOC_DQBUF50 () { &_IOWR(ord(\'V\'), 17, \'struct v4l2_buffer50\');}' unless defined(&VIDIOC_DQBUF50);
    }
}
1;
