require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_TERMIOS_H_)) {
    eval 'sub _SYS_TERMIOS_H_ () {1;}' unless defined(&_SYS_TERMIOS_H_);
    require 'sys/ansi.ph';
    require 'sys/featuretest.ph';
    eval 'sub VEOF () {0;}' unless defined(&VEOF);
    eval 'sub VEOL () {1;}' unless defined(&VEOL);
    if(defined(&_NETBSD_SOURCE)) {
	eval 'sub VEOL2 () {2;}' unless defined(&VEOL2);
    }
    eval 'sub VERASE () {3;}' unless defined(&VERASE);
    if(defined(&_NETBSD_SOURCE)) {
	eval 'sub VWERASE () {4;}' unless defined(&VWERASE);
    }
    eval 'sub VKILL () {5;}' unless defined(&VKILL);
    if(defined(&_NETBSD_SOURCE)) {
	eval 'sub VREPRINT () {6;}' unless defined(&VREPRINT);
    }
    eval 'sub VINTR () {8;}' unless defined(&VINTR);
    eval 'sub VQUIT () {9;}' unless defined(&VQUIT);
    eval 'sub VSUSP () {10;}' unless defined(&VSUSP);
    if(defined(&_NETBSD_SOURCE)) {
	eval 'sub VDSUSP () {11;}' unless defined(&VDSUSP);
    }
    eval 'sub VSTART () {12;}' unless defined(&VSTART);
    eval 'sub VSTOP () {13;}' unless defined(&VSTOP);
    if(defined(&_NETBSD_SOURCE)) {
	eval 'sub VLNEXT () {14;}' unless defined(&VLNEXT);
	eval 'sub VDISCARD () {15;}' unless defined(&VDISCARD);
    }
    eval 'sub VMIN () {16;}' unless defined(&VMIN);
    eval 'sub VTIME () {17;}' unless defined(&VTIME);
    if(defined(&_NETBSD_SOURCE)) {
	eval 'sub VSTATUS () {18;}' unless defined(&VSTATUS);
    }
    eval 'sub NCCS () {20;}' unless defined(&NCCS);
    eval 'sub _POSIX_VDISABLE () { &__CAST(\'unsigned char\', ord(\'\\377\'));}' unless defined(&_POSIX_VDISABLE);
    if(defined(&_NETBSD_SOURCE)) {
	eval 'sub CCEQ {
	    my($val, $c) = @_;
    	    eval q(($c == $val ? $val !=  &_POSIX_VDISABLE : 0));
	}' unless defined(&CCEQ);
    }
    eval 'sub IGNBRK () {0x1;}' unless defined(&IGNBRK);
    eval 'sub BRKINT () {0x2;}' unless defined(&BRKINT);
    eval 'sub IGNPAR () {0x4;}' unless defined(&IGNPAR);
    eval 'sub PARMRK () {0x8;}' unless defined(&PARMRK);
    eval 'sub INPCK () {0x10;}' unless defined(&INPCK);
    eval 'sub ISTRIP () {0x20;}' unless defined(&ISTRIP);
    eval 'sub INLCR () {0x40;}' unless defined(&INLCR);
    eval 'sub IGNCR () {0x80;}' unless defined(&IGNCR);
    eval 'sub ICRNL () {0x100;}' unless defined(&ICRNL);
    eval 'sub IXON () {0x200;}' unless defined(&IXON);
    eval 'sub IXOFF () {0x400;}' unless defined(&IXOFF);
    if(defined(&_XOPEN_SOURCE) || defined(&_NETBSD_SOURCE)) {
	eval 'sub IXANY () {0x800;}' unless defined(&IXANY);
    }
    if(defined(&_NETBSD_SOURCE)) {
	eval 'sub IMAXBEL () {0x2000;}' unless defined(&IMAXBEL);
    }
    eval 'sub OPOST () {0x1;}' unless defined(&OPOST);
    if(defined(&_XOPEN_SOURCE) || defined(&_NETBSD_SOURCE)) {
	eval 'sub ONLCR () {0x2;}' unless defined(&ONLCR);
    }
    if(defined(&_NETBSD_SOURCE)) {
	eval 'sub OXTABS () {0x4;}' unless defined(&OXTABS);
	eval 'sub ONOEOT () {0x8;}' unless defined(&ONOEOT);
    }
    if(defined(&_XOPEN_SOURCE) || defined(&_NETBSD_SOURCE)) {
	eval 'sub OCRNL () {0x10;}' unless defined(&OCRNL);
	eval 'sub ONOCR () {0x20;}' unless defined(&ONOCR);
	eval 'sub ONLRET () {0x40;}' unless defined(&ONLRET);
    }
    if(defined(&_NETBSD_SOURCE)) {
	eval 'sub CIGNORE () {0x1;}' unless defined(&CIGNORE);
    }
    eval 'sub CSIZE () {0x300;}' unless defined(&CSIZE);
    eval 'sub CS5 () {0x;}' unless defined(&CS5);
    eval 'sub CS6 () {0x100;}' unless defined(&CS6);
    eval 'sub CS7 () {0x200;}' unless defined(&CS7);
    eval 'sub CS8 () {0x300;}' unless defined(&CS8);
    eval 'sub CSTOPB () {0x400;}' unless defined(&CSTOPB);
    eval 'sub CREAD () {0x800;}' unless defined(&CREAD);
    eval 'sub PARENB () {0x1000;}' unless defined(&PARENB);
    eval 'sub PARODD () {0x2000;}' unless defined(&PARODD);
    eval 'sub HUPCL () {0x4000;}' unless defined(&HUPCL);
    eval 'sub CLOCAL () {0x8000;}' unless defined(&CLOCAL);
    if(defined(&_NETBSD_SOURCE)) {
	eval 'sub CRTSCTS () {0x10000;}' unless defined(&CRTSCTS);
	eval 'sub CRTS_IFLOW () { &CRTSCTS;}' unless defined(&CRTS_IFLOW);
	eval 'sub CCTS_OFLOW () { &CRTSCTS;}' unless defined(&CCTS_OFLOW);
	eval 'sub CDTRCTS () {0x20000;}' unless defined(&CDTRCTS);
	eval 'sub MDMBUF () {0x100000;}' unless defined(&MDMBUF);
	eval 'sub CHWFLOW () {( &MDMBUF| &CRTSCTS| &CDTRCTS);}' unless defined(&CHWFLOW);
    }
    if(defined(&_NETBSD_SOURCE)) {
	eval 'sub ECHOKE () {0x1;}' unless defined(&ECHOKE);
    }
    eval 'sub ECHOE () {0x2;}' unless defined(&ECHOE);
    eval 'sub ECHOK () {0x4;}' unless defined(&ECHOK);
    eval 'sub ECHO () {0x8;}' unless defined(&ECHO);
    eval 'sub ECHONL () {0x10;}' unless defined(&ECHONL);
    if(defined(&_NETBSD_SOURCE)) {
	eval 'sub ECHOPRT () {0x20;}' unless defined(&ECHOPRT);
	eval 'sub ECHOCTL () {0x40;}' unless defined(&ECHOCTL);
    }
    eval 'sub ISIG () {0x80;}' unless defined(&ISIG);
    eval 'sub ICANON () {0x100;}' unless defined(&ICANON);
    if(defined(&_NETBSD_SOURCE)) {
	eval 'sub ALTWERASE () {0x200;}' unless defined(&ALTWERASE);
    }
    eval 'sub IEXTEN () {0x400;}' unless defined(&IEXTEN);
    if(defined(&_NETBSD_SOURCE)) {
	eval 'sub EXTPROC () {0x800;}' unless defined(&EXTPROC);
    }
    eval 'sub TOSTOP () {0x400000;}' unless defined(&TOSTOP);
    if(defined(&_NETBSD_SOURCE)) {
	eval 'sub FLUSHO () {0x800000;}' unless defined(&FLUSHO);
	eval 'sub NOKERNINFO () {0x2000000;}' unless defined(&NOKERNINFO);
	eval 'sub PENDIN () {0x20000000;}' unless defined(&PENDIN);
    }
    eval 'sub NOFLSH () {0x80000000;}' unless defined(&NOFLSH);
    eval 'sub TCSANOW () {0;}' unless defined(&TCSANOW);
    eval 'sub TCSADRAIN () {1;}' unless defined(&TCSADRAIN);
    eval 'sub TCSAFLUSH () {2;}' unless defined(&TCSAFLUSH);
    if(defined(&_NETBSD_SOURCE)) {
	eval 'sub TCSASOFT () {0x10;}' unless defined(&TCSASOFT);
    }
    eval 'sub B0 () {0;}' unless defined(&B0);
    eval 'sub B50 () {50;}' unless defined(&B50);
    eval 'sub B75 () {75;}' unless defined(&B75);
    eval 'sub B110 () {110;}' unless defined(&B110);
    eval 'sub B134 () {134;}' unless defined(&B134);
    eval 'sub B150 () {150;}' unless defined(&B150);
    eval 'sub B200 () {200;}' unless defined(&B200);
    eval 'sub B300 () {300;}' unless defined(&B300);
    eval 'sub B600 () {600;}' unless defined(&B600);
    eval 'sub B1200 () {1200;}' unless defined(&B1200);
    eval 'sub B1800 () {1800;}' unless defined(&B1800);
    eval 'sub B2400 () {2400;}' unless defined(&B2400);
    eval 'sub B4800 () {4800;}' unless defined(&B4800);
    eval 'sub B9600 () {9600;}' unless defined(&B9600);
    eval 'sub B19200 () {19200;}' unless defined(&B19200);
    eval 'sub B38400 () {38400;}' unless defined(&B38400);
    if(defined(&_NETBSD_SOURCE)) {
	eval 'sub B7200 () {7200;}' unless defined(&B7200);
	eval 'sub B14400 () {14400;}' unless defined(&B14400);
	eval 'sub B28800 () {28800;}' unless defined(&B28800);
	eval 'sub B57600 () {57600;}' unless defined(&B57600);
	eval 'sub B76800 () {76800;}' unless defined(&B76800);
	eval 'sub B115200 () {115200;}' unless defined(&B115200);
	eval 'sub B230400 () {230400;}' unless defined(&B230400);
	eval 'sub B460800 () {460800;}' unless defined(&B460800);
	eval 'sub B500000 () {500000;}' unless defined(&B500000);
	eval 'sub B921600 () {921600;}' unless defined(&B921600);
	eval 'sub B1000000 () {1000000;}' unless defined(&B1000000);
	eval 'sub B1500000 () {1500000;}' unless defined(&B1500000);
	eval 'sub B2000000 () {2000000;}' unless defined(&B2000000);
	eval 'sub B2500000 () {2500000;}' unless defined(&B2500000);
	eval 'sub B3000000 () {3000000;}' unless defined(&B3000000);
	eval 'sub B3500000 () {3500000;}' unless defined(&B3500000);
	eval 'sub B4000000 () {4000000;}' unless defined(&B4000000);
	eval 'sub EXTA () {19200;}' unless defined(&EXTA);
	eval 'sub EXTB () {38400;}' unless defined(&EXTB);
    }
    unless(defined(&_KERNEL)) {
	eval 'sub TCIFLUSH () {1;}' unless defined(&TCIFLUSH);
	eval 'sub TCOFLUSH () {2;}' unless defined(&TCOFLUSH);
	eval 'sub TCIOFLUSH () {3;}' unless defined(&TCIOFLUSH);
	eval 'sub TCOOFF () {1;}' unless defined(&TCOOFF);
	eval 'sub TCOON () {2;}' unless defined(&TCOON);
	eval 'sub TCIOFF () {3;}' unless defined(&TCIOFF);
	eval 'sub TCION () {4;}' unless defined(&TCION);
	if(defined(&_XOPEN_SOURCE) || defined(&_NETBSD_SOURCE)) {
	    unless(defined(&pid_t)) {
		eval 'sub pid_t () { &__pid_t;}' unless defined(&pid_t);
	    }
	}
	require 'sys/cdefs.ph';
	if(defined(&_XOPEN_SOURCE) || defined(&_NETBSD_SOURCE)) {
	}
	if(defined(&_NETBSD_SOURCE)) {
	}
    }
    require 'sys/ttycom.ph';
}
if(defined(&_NETBSD_SOURCE)) {
    require 'sys/ttydefaults.ph';
}
1;
